/* eslint-disable @typescript-eslint/no-empty-interface */
// Generated code for namespace: org.isda.cdm@0.2.0

// imports
import {IConcept,IAsset,IEvent} from './concerto@1.0.0';

// interfaces
export interface IAdjustableDates extends IConcept {
   id: string;
   unadjustedDate: Date[];
   adjustedDate: Date[];
   dateAdjustments: IBusinessDayAdjustments;
}

export interface IAdjustableDatesBuilder extends IConcept {
   id: string;
   unadjustedDate: Date[];
   adjustedDate: Date[];
}

export interface IAmountSchedule extends IConcept {
   currency: string[];
   currencyScheme: string;
   id: string;
   initialValue: number;
   step: IStep[];
}

export interface IAmountScheduleBuilder extends IConcept {
   currency: string[];
   currencyScheme: string;
   id: string;
   initialValue: number;
}

export interface INonNegativeStep extends IConcept {
   id: string;
   stepDate: Date;
   stepValue: number;
}

export interface INonNegativeStepBuilder extends IConcept {
   id: string;
   stepDate: Date;
   stepValue: number;
}

export interface IComputedAmount extends IConcept {
   currency: string;
   callFunction: string;
   currencyScheme: string;
   amount: number;
}

export interface IComputedAmountBuilder extends IConcept {
   currency: string;
   callFunction: string;
   currencyScheme: string;
   amount: number;
}

export interface IInterestShortFall extends IConcept {
   interestShortfallCap: InterestShortfallCapEnum;
   compounding: boolean;
   rateSource: FloatingRateIndexEnum;
}

export interface IInterestShortFallBuilder extends IConcept {
   interestShortfallCap: InterestShortfallCapEnum;
   compounding: boolean;
   rateSource: FloatingRateIndexEnum;
}

export interface ITradeHeaderBuilder extends IConcept {
   tradeDate: Date;
}

export interface ITradeHeader extends IConcept {
   identifier: IPartyContractIdentifier[];
   tradeDate: Date;
}

export interface IPaymentDetail extends IConcept {
   id: string;
   paymentDate: IAdjustableOrAdjustedDate;
   paymentRule: IPaymentRule;
   paymentAmount: IMoney;
}

export interface IPaymentDetailBuilder extends IConcept {
   id: string;
}

export interface IPaymentRule extends IConcept {
   percentageRule: IPercentageRule;
}

export interface IPaymentRuleBuilder extends IConcept {
}

export interface IAllocationOutcome extends IConcept {
   execution: IExecutionReference;
   contractReference: IContractReference[];
   contract: IContract[];
}

export interface IAllocationOutcomeBuilder extends IConcept {
}

export interface IAccount extends IConcept {
   id: string;
   accountNumber: string;
   accountName: string;
   accountType: AccountTypeEnum;
   accountBeneficiary: string;
   servicingParty: string;
   accountNameScheme: string;
   accountNumberScheme: string;
   accountTypeScheme: string;
}

export interface IAccountBuilder extends IConcept {
   id: string;
   accountNumber: string;
   accountName: string;
   accountType: AccountTypeEnum;
   accountBeneficiary: string;
   servicingParty: string;
   accountNameScheme: string;
   accountNumberScheme: string;
   accountTypeScheme: string;
}

export enum ContractualDefinitionsEnum {
   ISDA1991 = 'ISDA1991',
   ISDA_1993_COMMODITY = 'ISDA_1993_COMMODITY',
   ISDA_1996_EQUITY = 'ISDA_1996_EQUITY',
   ISDA_1997_BULLION = 'ISDA_1997_BULLION',
   ISDA_1997_GOVERNMENT_BOND = 'ISDA_1997_GOVERNMENT_BOND',
   ISDA1998FX = 'ISDA1998FX',
   ISDA_1999_CREDIT = 'ISDA_1999_CREDIT',
   ISDA2000 = 'ISDA2000',
   ISDA_2002_EQUITY = 'ISDA_2002_EQUITY',
   ISDA_2003_CREDIT = 'ISDA_2003_CREDIT',
   ISDA_2004_NOVATION = 'ISDA_2004_NOVATION',
   ISDA_2005_COMMODITY = 'ISDA_2005_COMMODITY',
   ISDA2006 = 'ISDA2006',
   ISDA_2006_INFLATION = 'ISDA_2006_INFLATION',
   ISDA_2008_INFLATION = 'ISDA_2008_INFLATION',
   ISDA_2011_EQUITY = 'ISDA_2011_EQUITY',
   ISDA_2014_CREDIT = 'ISDA_2014_CREDIT',
}

export interface IBermudaExercise extends IConcept {
   id: string;
   relevantUnderlyingDate: IAdjustableOrRelativeDates;
   earliestExerciseTime: IBusinessCenterTime;
   expirationTime: IBusinessCenterTime;
   bermudaExerciseDates: IAdjustableOrRelativeDates;
   latestExerciseTime: IBusinessCenterTime;
   multipleExercise: IMultipleExercise;
   exerciseFeeSchedule: IExerciseFeeSchedule;
}

export interface IBermudaExerciseBuilder extends IConcept {
   id: string;
}

export interface IContractualMatrix extends IConcept {
   matrixType: MatrixTypeEnum;
   publicationDate: Date;
   matrixTerm: MatrixTermEnum;
   matrixTermScheme: string;
   matrixTypeScheme: string;
}

export interface IContractualMatrixBuilder extends IConcept {
   matrixType: MatrixTypeEnum;
   publicationDate: Date;
   matrixTerm: MatrixTermEnum;
   matrixTermScheme: string;
   matrixTypeScheme: string;
}

export interface IPhysicalExercise extends IConcept {
   cashflow: ICashflow;
   commodity: ICommodity;
   listedProduct: IListedProduct;
   quantity: IQuantity;
   contractReference: IContractReference[];
   contract: IContract[];
}

export interface IPhysicalExerciseBuilder extends IConcept {
}

export interface IInterestRateCurveBuilder extends IConcept {
   floatingRateIndexScheme: string;
   floatingRateIndex: FloatingRateIndexEnum;
}

export interface IInterestRateCurve extends IConcept {
   floatingRateIndexScheme: string;
   floatingRateIndex: FloatingRateIndexEnum;
   tenor: IPeriod;
}

export interface IRelativeDateOffset extends IConcept {
   businessDayConvention: BusinessDayConventionEnum;
   businessCenters: IBusinessCenters;
   businessCentersReference: string;
   dateRelativeTo: string;
   adjustedDate: Date;
   dayType: DayTypeEnum;
   id: string;
   period: PeriodEnum;
   periodMultiplier: number;
}

export interface IRelativeDateOffsetBuilder extends IConcept {
   businessDayConvention: BusinessDayConventionEnum;
   businessCentersReference: string;
   dateRelativeTo: string;
   adjustedDate: Date;
   dayType: DayTypeEnum;
   id: string;
   period: PeriodEnum;
   periodMultiplier: number;
}

export interface IPayoutLineage extends IConcept {
   cashflow: string;
   optionPayout: string;
   creditDefaultPayout: string;
   payoutReference: string;
   interestRatePayout: string;
}

export interface IPayoutLineageBuilder extends IConcept {
   cashflow: string;
   optionPayout: string;
   creditDefaultPayout: string;
   payoutReference: string;
   interestRatePayout: string;
}

export interface IManualExercise extends IConcept {
   exerciseNotice: IExerciseNotice;
   fallbackExercise: boolean;
}

export interface IManualExerciseBuilder extends IConcept {
   fallbackExercise: boolean;
}

export interface IGeneralTerms extends IConcept {
   additionalTermScheme: string;
   buyerSeller: IBuyerSeller;
   referenceInformation: IReferenceInformation;
   indexReferenceInformation: IIndexReferenceInformation;
   substitution: boolean;
   modifiedEquityDelivery: boolean;
   basketReferenceInformation: IBasketReferenceInformation;
   additionalTerm: string[];
   dateAdjustments: IBusinessDayAdjustments;
}

export interface IGeneralTermsBuilder extends IConcept {
   additionalTermScheme: string;
   substitution: boolean;
   modifiedEquityDelivery: boolean;
   additionalTerm: string[];
}

export interface IListedProduct extends IConcept {
   bond: IBond;
   convertibleBond: IConvertibleBond;
   rosettaKey: string;
}

export interface IListedProductBuilder extends IConcept {
}

export enum RoundingDirectionEnum {
   UP = 'UP',
   DOWN = 'DOWN',
   NEAREST = 'NEAREST',
}

export interface INewTradePrimitiveBuilder extends IConcept {
}

export interface INewTradePrimitive extends IConcept {
   contractReference: IContractIdentifier;
   contract: IContract;
}

export interface IIndexReferenceInformationBuilder extends IConcept {
   id: string;
   indexAnnexVersion: number;
   indexAnnexSourceScheme: string;
   indexIdScheme: string;
   indexNameScheme: string;
   indexSeries: number;
   indexName: string;
   indexId: string[];
   indexAnnexDate: Date;
   indexAnnexSource: IndexAnnexSourceEnum;
}

export interface IIndexReferenceInformation extends IConcept {
   id: string;
   indexAnnexVersion: number;
   indexAnnexSourceScheme: string;
   indexIdScheme: string;
   indexNameScheme: string;
   tranche: ITranche;
   indexSeries: number;
   indexName: string;
   indexId: string[];
   indexAnnexDate: Date;
   indexAnnexSource: IndexAnnexSourceEnum;
   excludedReferenceEntity: ILegalEntity[];
   settledEntityMatrix: ISettledEntityMatrix;
}

export interface IContractOrContractReference extends IConcept {
   contractReference: IContractReference[];
   contract: IContract[];
}

export interface IContractOrContractReferenceBuilder extends IConcept {
}

export enum StepRelativeToEnum {
   INITIAL = 'INITIAL',
   PREVIOUS = 'PREVIOUS',
}

export interface ITransactedPriceBuilder extends IConcept {
   initialPoints: number;
   quotationStyle: QuotationStyleEnum;
   marketFixedRate: number;
   marketPrice: number;
}

export interface ITransactedPrice extends IConcept {
   initialPoints: number;
   quotationStyle: QuotationStyleEnum;
   marketFixedRate: number;
   marketPrice: number;
}

export interface IStep extends IConcept {
   id: string;
   stepDate: Date;
   stepValue: number;
}

export interface IStepBuilder extends IConcept {
   id: string;
   stepDate: Date;
   stepValue: number;
}

export interface IFxLinkedNotionalAmount extends IConcept {
   notionalAmount: number;
   resetDate: Date;
   adjustedFxSpotFixingDate: Date;
   observedFxSpotRate: number;
}

export interface IFxLinkedNotionalAmountBuilder extends IConcept {
   notionalAmount: number;
   resetDate: Date;
   adjustedFxSpotFixingDate: Date;
   observedFxSpotRate: number;
}

export interface IEarlyTerminationEvent extends IConcept {
   id: string;
   adjustedEarlyTerminationDate: Date;
   adjustedExerciseFeePaymentDate: Date;
   adjustedCashSettlementValuationDate: Date;
   adjustedCashSettlementPaymentDate: Date;
   adjustedExerciseDate: Date;
}

export interface IEarlyTerminationEventBuilder extends IConcept {
   id: string;
   adjustedEarlyTerminationDate: Date;
   adjustedExerciseFeePaymentDate: Date;
   adjustedCashSettlementValuationDate: Date;
   adjustedCashSettlementPaymentDate: Date;
   adjustedExerciseDate: Date;
}

export interface IObservationPrimitive extends IConcept {
   side: QuotationSideEnum;
   source: IObservationSource;
   observation: number;
   date: Date;
   time: ITimeZone;
}

export interface IObservationPrimitiveBuilder extends IConcept {
   side: QuotationSideEnum;
   observation: number;
   date: Date;
}

export interface IValuationDate extends IConcept {
   singleValuationDate: ISingleValuationDate;
   multipleValuationDates: IMultipleValuationDates;
}

export interface IValuationDateBuilder extends IConcept {
}

export interface IPartyRole extends IConcept {
   role: PartyRoleEnum;
   partyReference: string;
}

export interface IPartyRoleBuilder extends IConcept {
   role: PartyRoleEnum;
   partyReference: string;
}

export enum TimeUnitEnum {
   SECOND = 'SECOND',
   MINUTE = 'MINUTE',
   HOUR = 'HOUR',
   DAY = 'DAY',
   WEEK = 'WEEK',
   MONTH = 'MONTH',
   YEAR = 'YEAR',
}

export interface ITimeZone extends IConcept {
   location: string;
   locationScheme: string;
   time: Date;
}

export interface ITimeZoneBuilder extends IConcept {
   location: string;
   locationScheme: string;
   time: Date;
}

export interface ITranche extends IConcept {
   attachmentPoint: number;
   exhaustionPoint: number;
   incurredRecoveryApplicable: boolean;
}

export interface ITrancheBuilder extends IConcept {
   attachmentPoint: number;
   exhaustionPoint: number;
   incurredRecoveryApplicable: boolean;
}

export interface IStrategyFeature extends IConcept {
   strikeSpread: IStrikeSpread;
   calendarSpread: ICalendarSpread;
}

export interface IStrategyFeatureBuilder extends IConcept {
}

export interface IFloatingAmountEvents extends IConcept {
   failureToPayPrincipal: boolean;
   writedown: boolean;
   impliedWritedown: boolean;
   additionalFixedPayments: IAdditionalFixedPayments;
   interestShortfall: IInterestShortFall;
   floatingAmountProvisions: IFloatingAmountProvisions;
}

export interface IFloatingAmountEventsBuilder extends IConcept {
   failureToPayPrincipal: boolean;
   writedown: boolean;
   impliedWritedown: boolean;
}

export interface ICollateral extends IConcept {
   independentAmount: IIndependentAmount;
}

export interface ICollateralBuilder extends IConcept {
}

export interface ICurveBuilder extends IConcept {
   commodityCurveScheme: string;
   commodityCurve: CommodityReferencePriceEnum;
}

export interface ICurve extends IConcept {
   commodityCurveScheme: string;
   interestRateCurve: IInterestRateCurve;
   commodityCurve: CommodityReferencePriceEnum;
}

export interface IPassThrough extends IConcept {
   passThroughItem: IPassThroughItem[];
}

export interface IPassThroughBuilder extends IConcept {
}

export enum QuotationStyleEnum {
   POINTS_UP_FRONT = 'POINTS_UP_FRONT',
   TRADED_SPREAD = 'TRADED_SPREAD',
   PRICE = 'PRICE',
}

export interface IReferencePoolItemBuilder extends IConcept {
   protectionTermsReference: string;
   settlementTermsReference: string;
}

export interface IReferencePoolItem extends IConcept {
   referencePair: IReferencePair;
   protectionTermsReference: string;
   settlementTermsReference: string;
   constituentWeight: IConstituentWeight;
}

export interface IStubPeriod extends IConcept {
   calculationPeriodDatesReference: string;
   initialStub: IStubValue;
   finalStub: IStubValue;
}

export interface IStubPeriodBuilder extends IConcept {
   calculationPeriodDatesReference: string;
}

export interface IEvent extends IConcept {
   effectiveDate: Date;
   primitive: IPrimitiveEvent;
   lineage: ILineage;
   messageInformation: IMessageInformation;
   eventIdentifier: IIdentifier;
   eventQualifier: string;
   eventDate: Date;
   action: ActionEnum;
   intent: IntentEnum;
   functionCall: string;
   eventEffect: IEventEffect;
   party: IParty[];
   rosettaKey: string;
   timestamp: IEventTimestamp;
}

export interface IEventBuilder extends IConcept {
   effectiveDate: Date;
   eventQualifier: string;
   eventDate: Date;
   action: ActionEnum;
   intent: IntentEnum;
   functionCall: string;
}

export interface ITransfer extends IConcept {
   grossCashflow: IGrossCashflow[];
   settlementReference: string;
   rosettaKey: string;
   transferDate: IAdjustableOrAdjustedOrRelativeDate;
   transferCalculation: string;
   transferType: TransferTypeEnum;
   transferStatus: TransferStatusEnum;
   payerReceiver: IPayerReceiver;
   asset: IAsset;
   transferorTransferee: ITransferorTransferee;
   quantity: IQuantity;
   amount: IMoney;
}

export interface ITransferBuilder extends IConcept {
   settlementReference: string;
   transferCalculation: string;
   transferType: TransferTypeEnum;
   transferStatus: TransferStatusEnum;
}

export enum SpreadScheduleTypeEnum {
   LONG = 'LONG',
   SHORT = 'SHORT',
}

export interface IAdditionalFixedPayments extends IConcept {
   interestShortfallReimbursement: boolean;
   principalShortfallReimbursement: boolean;
   writedownReimbursement: boolean;
}

export interface IAdditionalFixedPaymentsBuilder extends IConcept {
   interestShortfallReimbursement: boolean;
   principalShortfallReimbursement: boolean;
   writedownReimbursement: boolean;
}

export interface IEuropeanExerciseBuilder extends IConcept {
   id: string;
}

export interface IEuropeanExercise extends IConcept {
   id: string;
   expirationDate: IAdjustableOrRelativeDate;
   relevantUnderlyingDate: IAdjustableOrRelativeDates;
   earliestExerciseTime: IBusinessCenterTime;
   expirationTime: IBusinessCenterTime;
   partialExercise: IPartialExercise;
   exerciseFee: IExerciseFee;
}

export enum CreditSeniorityTradingEnum {
   SENIOR = 'SENIOR',
   SUBORDINATE = 'SUBORDINATE',
}

export interface IBarrier extends IConcept {
   barrierCap: ITriggerEvent;
   barrierFloor: ITriggerEvent;
}

export interface IBarrierBuilder extends IConcept {
}

export enum QuoteBasisEnum {
   CURRENCY_1_PER_CURRENCY_2 = 'CURRENCY_1_PER_CURRENCY_2',
   CURRENCY_2_PER_CURRENCY_1 = 'CURRENCY_2_PER_CURRENCY_1',
}

export interface IBusinessDayAdjustments extends IConcept {
   id: string;
   businessDayConvention: BusinessDayConventionEnum;
   businessCenters: IBusinessCenters;
}

export interface IBusinessDayAdjustmentsBuilder extends IConcept {
   id: string;
   businessDayConvention: BusinessDayConventionEnum;
}

export enum PeriodExtendedEnum {
   T = 'T',
   D = 'D',
   W = 'W',
   M = 'M',
   Y = 'Y',
}

export interface IFloatingRateDefinition extends IConcept {
   floatingRateMultiplier: number;
   spread: number;
   calculatedRate: number;
   rateObservation: IRateObservation[];
   capRate: IStrike[];
   floorRate: IStrike[];
}

export interface IFloatingRateDefinitionBuilder extends IConcept {
   floatingRateMultiplier: number;
   spread: number;
   calculatedRate: number;
}

export interface IAllocationPrimitiveBuilder extends IConcept {
}

export interface IAllocationPrimitive extends IConcept {
   before: IExecution;
   after: IAllocationOutcome;
}

export interface IFxRateBuilder extends IConcept {
   rate: number;
}

export interface IFxRate extends IConcept {
   quotedCurrencyPair: IQuotedCurrencyPair;
   rate: number;
}

export interface IExtendibleProvisionAdjustedDatesBuilder extends IConcept {
}

export interface IExtendibleProvisionAdjustedDates extends IConcept {
   extensionEvent: IExtensionEvent[];
}

export interface IRelativeDatesBuilder extends IConcept {
   periodSkip: number;
   businessDayConvention: BusinessDayConventionEnum;
   businessCentersReference: string;
   dateRelativeTo: string;
   adjustedDate: Date;
   dayType: DayTypeEnum;
   id: string;
   period: PeriodEnum;
   periodMultiplier: number;
}

export interface IRelativeDates extends IConcept {
   periodSkip: number;
   scheduleBounds: IDateRange;
   businessDayConvention: BusinessDayConventionEnum;
   businessCenters: IBusinessCenters;
   businessCentersReference: string;
   dateRelativeTo: string;
   adjustedDate: Date;
   dayType: DayTypeEnum;
   id: string;
   period: PeriodEnum;
   periodMultiplier: number;
}

export enum ActionEnum {
   NEW = 'NEW',
   CORRECT = 'CORRECT',
   CANCEL = 'CANCEL',
}

export interface IOptionStrike extends IConcept {
   currency: string;
   spread: number;
   referenceSwapCurve: IReferenceSwapCurve;
   price: number;
   percentage: number;
   strikeReference: string;
   currencyScheme: string;
}

export interface IOptionStrikeBuilder extends IConcept {
   currency: string;
   spread: number;
   price: number;
   percentage: number;
   strikeReference: string;
   currencyScheme: string;
}

export interface IResetPrimitive extends IConcept {
   cashflow: ICashflow;
   resetValue: number;
   rosettaKey: string;
   date: Date;
}

export interface IResetPrimitiveBuilder extends IConcept {
   resetValue: number;
   date: Date;
}

export interface IAveragingPeriodBuilder extends IConcept {
   marketDisruptionScheme: string;
   marketDisruption: MarketDisruptionEnum;
}

export interface IAveragingPeriod extends IConcept {
   marketDisruptionScheme: string;
   averagingDateTimes: IDateTimeList;
   averagingObservations: IAveragingObservationList;
   marketDisruption: MarketDisruptionEnum;
   schedule: IAveragingSchedule[];
}

export interface IPercentageRuleBuilder extends IConcept {
   paymentPercent: number;
   notionalAmountReference: string;
}

export interface IPercentageRule extends IConcept {
   paymentPercent: number;
   notionalAmountReference: string;
}

export interface ICalculationAgent extends IConcept {
   calculationAgentBusinessCenterScheme: string;
   calculationAgentBusinessCenter: BusinessCenterEnum;
   calculationAgentPartyReference: string[];
   calculationAgentParty: CalculationAgentPartyEnum;
}

export interface ICalculationAgentBuilder extends IConcept {
   calculationAgentBusinessCenterScheme: string;
   calculationAgentBusinessCenter: BusinessCenterEnum;
   calculationAgentPartyReference: string[];
   calculationAgentParty: CalculationAgentPartyEnum;
}

export interface INaturalPerson extends IConcept {
   id: string;
   honorific: string;
   firstName: string;
   middleName: string[];
   initial: string[];
   surname: string;
   suffix: string;
   dateOfBirth: Date;
}

export interface INaturalPersonBuilder extends IConcept {
   id: string;
   honorific: string;
   firstName: string;
   middleName: string[];
   initial: string[];
   surname: string;
   suffix: string;
   dateOfBirth: Date;
}

export interface IBusinessDateRangeBuilder extends IConcept {
   businessDayConvention: BusinessDayConventionEnum;
   unadjustedFirstDate: Date;
   unadjustedLastDate: Date;
}

export interface IBusinessDateRange extends IConcept {
   businessDayConvention: BusinessDayConventionEnum;
   businessCenters: IBusinessCenters;
   unadjustedFirstDate: Date;
   unadjustedLastDate: Date;
}

export interface ICancelableProvision extends IConcept {
   followUpConfirmation: boolean;
   americanExercise: IAmericanExercise;
   bermudaExercise: IBermudaExercise;
   europeanExercise: IEuropeanExercise;
   exerciseNotice: IExerciseNotice;
   initialFee: ISimplePayment;
   cancelableProvisionAdjustedDates: ICancelableProvisionAdjustedDates;
   finalCalculationPeriodDateAdjustment: IFinalCalculationPeriodDateAdjustment[];
   sellerPartyReference: string;
   buyerPartyReference: string;
   buyerAccountReference: string;
   sellerAccountReference: string;
}

export interface ICancelableProvisionBuilder extends IConcept {
   followUpConfirmation: boolean;
   sellerPartyReference: string;
   buyerPartyReference: string;
   buyerAccountReference: string;
   sellerAccountReference: string;
}

export enum BrokerConfirmationTypeEnum {
   ABX = 'ABX',
   CD_SON_MBS = 'CD_SON_MBS',
}

export enum QuotationRateTypeEnum {
   BID = 'BID',
   ASK = 'ASK',
   MID = 'MID',
   EXERCISING_PARTY_PAYS = 'EXERCISING_PARTY_PAYS',
}

export interface IPriceSourceDisruptionBuilder extends IConcept {
}

export interface IPriceSourceDisruption extends IConcept {
   fallbackReferencePrice: IFallbackReferencePrice;
}

export interface ICreditDefaultPayout extends IConcept {
   id: string;
   physicalSettlementTerms: IPhysicalSettlementTerms;
   rosettaKeyValue: string;
   protectionTerms: IProtectionTerms;
   generalTerms: IGeneralTerms;
   cashSettlementTerms: ICashSettlementTerms;
   transactedPrice: ITransactedPrice;
}

export interface ICreditDefaultPayoutBuilder extends IConcept {
   id: string;
}

export interface ICashPriceMethodBuilder extends IConcept {
   cashSettlementCurrencyScheme: string;
   cashSettlementCurrency: string;
   quotationRateType: QuotationRateTypeEnum;
}

export interface ICashPriceMethod extends IConcept {
   cashSettlementCurrencyScheme: string;
   cashSettlementReferenceBanks: ICashSettlementReferenceBanks;
   cashSettlementCurrency: string;
   quotationRateType: QuotationRateTypeEnum;
}

export enum TimeTypeEnum {
   CLOSE = 'CLOSE',
   OPEN = 'OPEN',
   OSP = 'OSP',
   SPECIFIC_TIME = 'SPECIFIC_TIME',
   XETRA = 'XETRA',
   DERIVATIVES_CLOSE = 'DERIVATIVES_CLOSE',
   AS_SPECIFIED_IN_MASTER_CONFIRMATION = 'AS_SPECIFIED_IN_MASTER_CONFIRMATION',
}

export enum InformationProviderEnum {
   BANK_OF_JAPAN = 'BANK_OF_JAPAN',
   BLOOMBERG = 'BLOOMBERG',
   ISDA = 'ISDA',
   REUTERS = 'REUTERS',
   TELERATE = 'TELERATE',
   OTHER = 'OTHER',
}

export enum RollConventionEnum {
   EOM = 'EOM',
   FRN = 'FRN',
   IMM = 'IMM',
   IMMCAD = 'IMMCAD',
   IMMAUD = 'IMMAUD',
   IMMNZD = 'IMMNZD',
   SFE = 'SFE',
   NONE = 'NONE',
   TBILL = 'TBILL',
   _1 = '_1',
   _2 = '_2',
   _3 = '_3',
   _4 = '_4',
   _5 = '_5',
   _6 = '_6',
   _7 = '_7',
   _8 = '_8',
   _9 = '_9',
   _10 = '_10',
   _11 = '_11',
   _12 = '_12',
   _13 = '_13',
   _14 = '_14',
   _15 = '_15',
   _16 = '_16',
   _17 = '_17',
   _18 = '_18',
   _19 = '_19',
   _20 = '_20',
   _21 = '_21',
   _22 = '_22',
   _23 = '_23',
   _24 = '_24',
   _25 = '_25',
   _26 = '_26',
   _27 = '_27',
   _28 = '_28',
   _29 = '_29',
   _30 = '_30',
   MON = 'MON',
   TUE = 'TUE',
   WED = 'WED',
   THU = 'THU',
   FRI = 'FRI',
   SAT = 'SAT',
   SUN = 'SUN',
}

export interface IMortgage extends IConcept {
   paymentFrequency: IPeriod;
   dayCountFractionScheme: string;
   sectorScheme: string;
   tranche: string;
   insurer: IParty;
   insurerReference: string;
   originalPrincipalAmount: number;
   sector: MortgageSectorEnum;
   dayCountFraction: DayCountFractionEnum;
   pool: IAssetPool;
   couponTypeScheme: string;
   seniorityScheme: string;
   issuerName: string;
   issuerReference: string;
   seniority: CreditSeniorityEnum;
   couponType: CouponTypeEnum;
   couponRate: number;
   maturity: Date;
   issueDate: Date;
   id: string;
   currency: string;
   clearanceSystemScheme: string;
   productIdentifierScheme: string;
   productIdentifier: IProductIdentifier[];
   productTaxonomy: IProductTaxonomy[];
   description: string;
   clearanceSystem: string;
   currencyScheme: string;
}

export interface IMortgageBuilder extends IConcept {
   dayCountFractionScheme: string;
   sectorScheme: string;
   tranche: string;
   insurerReference: string;
   originalPrincipalAmount: number;
   sector: MortgageSectorEnum;
   dayCountFraction: DayCountFractionEnum;
   couponTypeScheme: string;
   seniorityScheme: string;
   issuerName: string;
   issuerReference: string;
   seniority: CreditSeniorityEnum;
   couponType: CouponTypeEnum;
   couponRate: number;
   maturity: Date;
   issueDate: Date;
   id: string;
   currency: string;
   clearanceSystemScheme: string;
   productIdentifierScheme: string;
   description: string;
   clearanceSystem: string;
   currencyScheme: string;
}

export enum AssetClassEnum {
   COMMODITY = 'COMMODITY',
   CREDIT = 'CREDIT',
   EQUITY = 'EQUITY',
   FOREIGN_EXCHANGE = 'FOREIGN_EXCHANGE',
   INTEREST_RATE = 'INTEREST_RATE',
}

export enum GoverningLawEnum {
   AS_SPECIFIED_IN_MASTER_AGREEMENT = 'AS_SPECIFIED_IN_MASTER_AGREEMENT',
}

export enum CategoryEnum {
   TBD = 'TBD',
}

export interface IPaymentDiscounting extends IConcept {
   discountFactor: number;
   presentValueAmount: IMoney;
}

export interface IPaymentDiscountingBuilder extends IConcept {
   discountFactor: number;
}

export interface IReferenceSwapCurve extends IConcept {
   swapUnwindValue: ISwapCurveValuation;
   makeWholeAmount: IMakeWholeAmount;
}

export interface IReferenceSwapCurveBuilder extends IConcept {
}

export interface IInterestRate extends IConcept {
   floatingRate: IFloatingRateCalculation;
   inflationRate: IInflationRateCalculation;
   fixedRate: ISchedule;
}

export interface IInterestRateBuilder extends IConcept {
}

export interface IPartyContractIdentifierBuilder extends IConcept {
   accountReference: string;
   partyReference: string;
   issuer: string;
   issuerScheme: string;
   version: number;
}

export interface IPartyContractIdentifier extends IConcept {
   linkId: ILinkId[];
   allocationTradeId: IContractIdentifier[];
   resultingTradeId: IContractIdentifierExtended[];
   blockTradeId: IContractIdentifier;
   originatingTradeId: IContractIdentifier[];
   accountReference: string;
   partyReference: string;
   identifierValue: IIdentifierValue;
   issuer: string;
   issuerScheme: string;
   version: number;
}

export enum OptionTypeEnum {
   PUT = 'PUT',
   CALL = 'CALL',
   PAYER = 'PAYER',
   RECEIVER = 'RECEIVER',
   STRADDLE = 'STRADDLE',
}

export interface IConvertibleBondBuilder extends IConcept {
   redemptionDate: Date;
   dayCountFractionScheme: string;
   parValue: number;
   issuanceFaceAmount: number;
   dayCountFraction: DayCountFractionEnum;
   couponTypeScheme: string;
   seniorityScheme: string;
   issuerName: string;
   issuerReference: string;
   seniority: CreditSeniorityEnum;
   couponType: CouponTypeEnum;
   couponRate: number;
   maturity: Date;
   issueDate: Date;
   id: string;
   currency: string;
   clearanceSystemScheme: string;
   productIdentifierScheme: string;
   description: string;
   clearanceSystem: string;
   currencyScheme: string;
}

export interface IConvertibleBond extends IConcept {
   underlyingEquity: IEquityAsset;
   redemptionDate: Date;
   paymentFrequency: IPeriod;
   dayCountFractionScheme: string;
   parValue: number;
   issuanceFaceAmount: number;
   dayCountFraction: DayCountFractionEnum;
   couponTypeScheme: string;
   seniorityScheme: string;
   issuerName: string;
   issuerReference: string;
   seniority: CreditSeniorityEnum;
   couponType: CouponTypeEnum;
   couponRate: number;
   maturity: Date;
   issueDate: Date;
   id: string;
   currency: string;
   clearanceSystemScheme: string;
   productIdentifierScheme: string;
   productIdentifier: IProductIdentifier[];
   productTaxonomy: IProductTaxonomy[];
   description: string;
   clearanceSystem: string;
   currencyScheme: string;
}

export interface IOffset extends IConcept {
   dayType: DayTypeEnum;
   id: string;
   period: PeriodEnum;
   periodMultiplier: number;
}

export interface IOffsetBuilder extends IConcept {
   dayType: DayTypeEnum;
   id: string;
   period: PeriodEnum;
   periodMultiplier: number;
}

export enum StandardSettlementStyleEnum {
   STANDARD = 'STANDARD',
   NET = 'NET',
   STANDARD_AND_NET = 'STANDARD_AND_NET',
}

export interface IPaymentDates extends IConcept {
   id: string;
   paymentFrequency: IFrequency;
   paymentDaysOffset: IOffset;
   lastRegularPaymentDate: Date;
   resetDatesReference: string;
   valuationDatesReference: string;
   paymentDelay: boolean;
   payRelativeTo: PayRelativeToEnum;
   firstPaymentDate: Date;
   calculationPeriodDatesReference: string;
   paymentDatesAdjustments: IBusinessDayAdjustments;
}

export interface IPaymentDatesBuilder extends IConcept {
   id: string;
   lastRegularPaymentDate: Date;
   resetDatesReference: string;
   valuationDatesReference: string;
   paymentDelay: boolean;
   payRelativeTo: PayRelativeToEnum;
   firstPaymentDate: Date;
   calculationPeriodDatesReference: string;
}

export interface IQuotedCurrencyPair extends IConcept {
   currency1: string;
   currency2: string;
   quoteBasis: QuoteBasisEnum;
   currency1Scheme: string;
   currency2Scheme: string;
}

export interface IQuotedCurrencyPairBuilder extends IConcept {
   currency1: string;
   currency2: string;
   quoteBasis: QuoteBasisEnum;
   currency1Scheme: string;
   currency2Scheme: string;
}

export interface IObservationSource extends IConcept {
   curve: ICurve;
   informationSource: IInformationSource;
}

export interface IObservationSourceBuilder extends IConcept {
}

export interface IContractIdentifierExtended extends IConcept {
   associatedParty: string;
   accountReference: string;
   partyReference: string;
   identifierValue: IIdentifierValue;
   issuer: string;
   issuerScheme: string;
   version: number;
}

export interface IContractIdentifierExtendedBuilder extends IConcept {
   associatedParty: string;
   accountReference: string;
   partyReference: string;
   issuer: string;
   issuerScheme: string;
   version: number;
}

export interface IStrikeBuilder extends IConcept {
   id: string;
   buyer: PayerReceiverEnum;
   seller: PayerReceiverEnum;
   strikeRate: number;
}

export interface IStrike extends IConcept {
   id: string;
   buyer: PayerReceiverEnum;
   seller: PayerReceiverEnum;
   strikeRate: number;
}

export enum PaymentTypeEnum {
   NET_CASHFLOW = 'NET_CASHFLOW',
   BROKERAGE_COMMISSION = 'BROKERAGE_COMMISSION',
   FEE = 'FEE',
   INTEREST = 'INTEREST',
   NET_INTEREST = 'NET_INTEREST',
   NOVATION_FEE = 'NOVATION_FEE',
   PREMIUM = 'PREMIUM',
   TERMINATION_FEE = 'TERMINATION_FEE',
}

export interface IStrikeSchedule extends IConcept {
   buyer: PayerReceiverEnum;
   seller: PayerReceiverEnum;
   id: string;
   initialValue: number;
   step: IStep[];
}

export interface IStrikeScheduleBuilder extends IConcept {
   buyer: PayerReceiverEnum;
   seller: PayerReceiverEnum;
   id: string;
   initialValue: number;
}

export enum AveragingMethodEnum {
   UNWEIGHTED = 'UNWEIGHTED',
   WEIGHTED = 'WEIGHTED',
}

export enum IntentEnum {
   ALLOCATION = 'ALLOCATION',
   COMPRESSION = 'COMPRESSION',
   CORRECTION = 'CORRECTION',
   EARLY_TERMINATION = 'EARLY_TERMINATION',
   EXERCISE = 'EXERCISE',
   INCREASE = 'INCREASE',
   NEW_TRADE = 'NEW_TRADE',
   NOVATION = 'NOVATION',
   PARTIAL_NOVATION = 'PARTIAL_NOVATION',
   PARTIAL_TERMINATION = 'PARTIAL_TERMINATION',
   PORTFOLIO_COMPRESSION = 'PORTFOLIO_COMPRESSION',
   RENEGOTIATION = 'RENEGOTIATION',
   TERMINATION = 'TERMINATION',
}

export interface IExercisePrimitive extends IConcept {
   before: IContractOrContractReference;
   exerciseDate: Date;
   exerciseTime: Date;
   fullExercise: boolean;
   after: IExerciseOutcome;
}

export interface IExercisePrimitiveBuilder extends IConcept {
   exerciseDate: Date;
   exerciseTime: Date;
   fullExercise: boolean;
}

export enum DayOfWeekEnum {
   MON = 'MON',
   TUE = 'TUE',
   WED = 'WED',
   THU = 'THU',
   FRI = 'FRI',
   SAT = 'SAT',
   SUN = 'SUN',
}

export enum AccountTypeEnum {
   AGGREGATE_CLIENT = 'AGGREGATE_CLIENT',
   CLIENT = 'CLIENT',
   HOUSE = 'HOUSE',
}

export interface IAdjustedRelativeDateOffset extends IConcept {
   relativeDateAdjustments: IBusinessDayAdjustments;
   businessDayConvention: BusinessDayConventionEnum;
   businessCenters: IBusinessCenters;
   businessCentersReference: string;
   dateRelativeTo: string;
   adjustedDate: Date;
   dayType: DayTypeEnum;
   id: string;
   period: PeriodEnum;
   periodMultiplier: number;
}

export interface IAdjustedRelativeDateOffsetBuilder extends IConcept {
   businessDayConvention: BusinessDayConventionEnum;
   businessCentersReference: string;
   dateRelativeTo: string;
   adjustedDate: Date;
   dayType: DayTypeEnum;
   id: string;
   period: PeriodEnum;
   periodMultiplier: number;
}

export interface ICreditSupportAgreementBuilder extends IConcept {
   type: CreditSupportAgreementTypeEnum;
   identifierValue: string;
   date: Date;
   typeScheme: string;
}

export interface ICreditSupportAgreement extends IConcept {
   type: CreditSupportAgreementTypeEnum;
   identifierValue: string;
   date: Date;
   typeScheme: string;
}

export enum PaymentStatusEnum {
   DISPUTED = 'DISPUTED',
   INSTRUCTED = 'INSTRUCTED',
   PENDING = 'PENDING',
   SETTLED = 'SETTLED',
}

export interface ILinkId extends IConcept {
   id: string;
   linkId: string;
   linkIdScheme: string;
}

export interface ILinkIdBuilder extends IConcept {
   id: string;
   linkId: string;
   linkIdScheme: string;
}

export enum MasterConfirmationTypeEnum {
   CREDIT_INDEX_2003 = 'CREDIT_INDEX_2003',
   DJ_CDX_NA = 'DJ_CDX_NA',
   DJ_I_TRAXX_EUROPE = 'DJ_I_TRAXX_EUROPE',
   ISDA_1999_CREDIT = 'ISDA_1999_CREDIT',
   ISDA_2003_CREDIT_JAPAN = 'ISDA_2003_CREDIT_JAPAN',
   ISDA_2003_CREDIT_NORTH_AMERICAN = 'ISDA_2003_CREDIT_NORTH_AMERICAN',
}

export enum MatrixTypeEnum {
   CREDIT_DERIVATIVES_PHYSICAL_SETTLEMENT_MATRIX = 'CREDIT_DERIVATIVES_PHYSICAL_SETTLEMENT_MATRIX',
   EQUITY_DERIVATIVES_MATRIX = 'EQUITY_DERIVATIVES_MATRIX',
   SETTLEMENT_MATRIX = 'SETTLEMENT_MATRIX',
}

export interface IExtendibleProvisionBuilder extends IConcept {
   followUpConfirmation: boolean;
   sellerPartyReference: string;
   buyerPartyReference: string;
   buyerAccountReference: string;
   sellerAccountReference: string;
}

export interface IExtendibleProvision extends IConcept {
   followUpConfirmation: boolean;
   americanExercise: IAmericanExercise;
   bermudaExercise: IBermudaExercise;
   europeanExercise: IEuropeanExercise;
   exerciseNotice: IExerciseNotice;
   extendibleProvisionAdjustedDates: IExtendibleProvisionAdjustedDates;
   sellerPartyReference: string;
   buyerPartyReference: string;
   buyerAccountReference: string;
   sellerAccountReference: string;
}

export enum InterestShortfallCapEnum {
   FIXED = 'FIXED',
   VARIABLE = 'VARIABLE',
}

export interface IExtensionEvent extends IConcept {
   id: string;
   adjustedExerciseDate: Date;
   adjustedExtendedTerminationDate: Date;
}

export interface IExtensionEventBuilder extends IConcept {
   id: string;
   adjustedExerciseDate: Date;
   adjustedExtendedTerminationDate: Date;
}

export enum CreditSeniorityEnum {
   OTHER = 'OTHER',
   SENIOR_SEC = 'SENIOR_SEC',
   SENIOR_UN_SEC = 'SENIOR_UN_SEC',
   SUB_LOWER_TIER_2 = 'SUB_LOWER_TIER_2',
   SUB_TIER_1 = 'SUB_TIER_1',
   SUB_TIER_3 = 'SUB_TIER_3',
   SUB_UPPER_TIER_2 = 'SUB_UPPER_TIER_2',
}

export enum InterpolationMethodEnum {
   LINEAR_ZERO_YIELD = 'LINEAR_ZERO_YIELD',
   NONE = 'NONE',
}

export interface IAdjustableOrAdjustedDate extends IConcept {
   id: string;
   unadjustedDate: Date;
   adjustedDate: Date;
   dateAdjustments: IBusinessDayAdjustments;
}

export interface IAdjustableOrAdjustedDateBuilder extends IConcept {
   id: string;
   unadjustedDate: Date;
   adjustedDate: Date;
}

export interface IBuyerSeller extends IConcept {
   sellerPartyReference: string;
   buyerPartyReference: string;
   buyerAccountReference: string;
   sellerAccountReference: string;
}

export interface IBuyerSellerBuilder extends IConcept {
   sellerPartyReference: string;
   buyerPartyReference: string;
   buyerAccountReference: string;
   sellerAccountReference: string;
}

export interface IPaymentBuilder extends IConcept {
   paymentType: PaymentTypeEnum;
   paymentStatus: PaymentStatusEnum;
   settlementReference: string;
   id: string;
   discountFactor: number;
}

export interface IPayment extends IConcept {
   paymentType: PaymentTypeEnum;
   paymentDate: IAdjustableOrAdjustedOrRelativeDate;
   grossCashflow: IGrossCashflow[];
   paymentStatus: PaymentStatusEnum;
   settlementReference: string;
   rosettaKey: string;
   paymentAmount: IMoney;
   id: string;
   discountFactor: number;
   presentValueAmount: IMoney;
   premiumExpression: IPremiumExpression;
   paymentDiscounting: IPaymentDiscounting;
   payerReceiver: IPayerReceiver;
}

export enum LengthUnitEnum {
   PAGES = 'PAGES',
   TIME_UNIT = 'TIME_UNIT',
}

export interface ISingleValuationDateBuilder extends IConcept {
   businessDays: number;
}

export interface ISingleValuationDate extends IConcept {
   businessDays: number;
}

export enum PayerReceiverEnum {
   PAYER = 'PAYER',
   RECEIVER = 'RECEIVER',
}

export interface IFloatingRateCalculation extends IConcept {
   initialRate: number;
   finalRateRounding: IRounding;
   averagingMethod: AveragingMethodEnum;
   negativeInterestRateTreatment: NegativeInterestRateTreatmentEnum;
   id: string;
   spreadSchedule: ISpreadSchedule[];
   floatingRateIndexScheme: string;
   floatingRateMultiplierSchedule: ISchedule;
   floatingRateIndex: FloatingRateIndexEnum;
   indexTenor: IPeriod;
   rateTreatment: RateTreatmentEnum;
   capRateSchedule: IStrikeSchedule[];
   floorRateSchedule: IStrikeSchedule[];
}

export interface IFloatingRateCalculationBuilder extends IConcept {
   initialRate: number;
   averagingMethod: AveragingMethodEnum;
   negativeInterestRateTreatment: NegativeInterestRateTreatmentEnum;
   id: string;
   floatingRateIndexScheme: string;
   floatingRateIndex: FloatingRateIndexEnum;
   rateTreatment: RateTreatmentEnum;
}

export interface IEventTestBundleBuilder extends IConcept {
}

export interface IEventTestBundle extends IConcept {
   event: IEvent[];
   computedAmount: IComputedAmount[];
}

export interface INonDeliverableSettlementBuilder extends IConcept {
   referenceCurrency: string;
   settlementRateOption: SettlementRateOptionEnum;
   referenceCurrencyScheme: string;
   settlementRateOptionScheme: string;
}

export interface INonDeliverableSettlement extends IConcept {
   referenceCurrency: string;
   fxFixingDate: IFxFixingDate;
   fxFixingSchedule: IAdjustableDates;
   settlementRateOption: SettlementRateOptionEnum;
   priceSourceDisruption: IPriceSourceDisruption;
   referenceCurrencyScheme: string;
   settlementRateOptionScheme: string;
}

export interface IAutomaticExercise extends IConcept {
   thresholdRate: number;
}

export interface IAutomaticExerciseBuilder extends IConcept {
   thresholdRate: number;
}

export enum MasterConfirmationAnnexTypeEnum {
   ISDA_2004_INDEX_VARIANCE_SWAP_AMERICAS_INTERDEALER = 'ISDA_2004_INDEX_VARIANCE_SWAP_AMERICAS_INTERDEALER',
}

export interface ICalculationPeriodFrequency extends IConcept {
   rollConvention: RollConventionEnum;
   id: string;
   period: PeriodExtendedEnum;
   periodMultiplier: number;
}

export interface ICalculationPeriodFrequencyBuilder extends IConcept {
   rollConvention: RollConventionEnum;
   id: string;
   period: PeriodExtendedEnum;
   periodMultiplier: number;
}

export interface ICashflowRepresentationBuilder extends IConcept {
   cashflowsMatchParameters: boolean;
}

export interface ICashflowRepresentation extends IConcept {
   cashflowsMatchParameters: boolean;
   principalExchange: IPrincipalExchange[];
   paymentCalculationPeriod: IPaymentCalculationPeriod[];
}

export interface IDiscountingBuilder extends IConcept {
   discountRateDayCountFraction: DayCountFractionEnum;
   discountRate: number;
   discountingType: DiscountingTypeEnum;
   discountRateDayCountFractionScheme: string;
}

export interface IDiscounting extends IConcept {
   discountRateDayCountFraction: DayCountFractionEnum;
   discountRate: number;
   discountingType: DiscountingTypeEnum;
   discountRateDayCountFractionScheme: string;
}

export interface IYieldCurveMethod extends IConcept {
   quotationRateType: QuotationRateTypeEnum;
   settlementRateSource: ISettlementRateSource;
}

export interface IYieldCurveMethodBuilder extends IConcept {
   quotationRateType: QuotationRateTypeEnum;
}

export enum CreditSupportAgreementTypeEnum {
   ISDA_1994_CREDIT_SUPPORT_ANNEX_NEW_YORK_LAW = 'ISDA_1994_CREDIT_SUPPORT_ANNEX_NEW_YORK_LAW',
   ISDA_1995_CREDIT_SUPPORT_ANNEX_ENGLISH_LAW = 'ISDA_1995_CREDIT_SUPPORT_ANNEX_ENGLISH_LAW',
   ISDA_1995_CREDIT_SUPPORT_ANNEX_JAPANESE_LAW = 'ISDA_1995_CREDIT_SUPPORT_ANNEX_JAPANESE_LAW',
   ISDA_1995_CREDIT_SUPPORT_DEED_ENGLISH_LAW = 'ISDA_1995_CREDIT_SUPPORT_DEED_ENGLISH_LAW',
   ISDA_2001_MARGIN_PROVISIONS = 'ISDA_2001_MARGIN_PROVISIONS',
   ISDA_2013_STANDARD_CREDIT_SUPPORT_AGREEMENT = 'ISDA_2013_STANDARD_CREDIT_SUPPORT_AGREEMENT',
   ISDA_2014_STANDARD_CREDIT_SUPPORT_AGREEMENT = 'ISDA_2014_STANDARD_CREDIT_SUPPORT_AGREEMENT',
}

export interface IOptionExercise extends IConcept {
   optionStyle: IOptionStyle;
   strike: IOptionStrike;
   exerciseProcedure: IExerciseProcedure;
   settlement: IOptionSettlement;
}

export interface IOptionExerciseBuilder extends IConcept {
}

export interface ICashSettlementPaymentDateBuilder extends IConcept {
   id: string;
}

export interface ICashSettlementPaymentDate extends IConcept {
   id: string;
   adjustableDates: IAdjustableDates;
   businessDateRange: IBusinessDateRange;
   relativeDate: IRelativeDateOffset;
}

export interface IDateList extends IConcept {
   date: Date[];
}

export interface IDateListBuilder extends IConcept {
   date: Date[];
}

export interface IDateRange extends IConcept {
   unadjustedFirstDate: Date;
   unadjustedLastDate: Date;
}

export interface IDateRangeBuilder extends IConcept {
   unadjustedFirstDate: Date;
   unadjustedLastDate: Date;
}

export interface IPrimitiveEvent extends IConcept {
   payment: IPayment[];
   observation: IObservationPrimitive[];
   transfer: ITransfer[];
   newTrade: INewTradePrimitive[];
   inception: IInception[];
   quantityChange: IQuantityChangePrimitive[];
   allocation: IAllocationPrimitive[];
   termsChange: ITermsChangePrimitive;
   exercise: IExercisePrimitive;
   reset: IResetPrimitive[];
}

export interface IPrimitiveEventBuilder extends IConcept {
}

export interface IStubValueBuilder extends IConcept {
   stubRate: number;
}

export interface IStubValue extends IConcept {
   floatingRate: IStubFloatingRate[];
   stubRate: number;
   stubAmount: IMoney;
}

export enum PartyRoleEnum {
   BARRIER_DETERMINATION_AGENT = 'BARRIER_DETERMINATION_AGENT',
   BENEFICIARY = 'BENEFICIARY',
   BROKER = 'BROKER',
   DETERMINING_PARTY = 'DETERMINING_PARTY',
   HEDGING_PARTY = 'HEDGING_PARTY',
}

export interface IGrossCashflowBuilder extends IConcept {
   cashflowCalculation: string;
   cashflowType: CashflowTypeEnum;
   id: string;
   discountFactor: number;
}

export interface IGrossCashflow extends IConcept {
   payoutLineage: IPayoutLineage;
   cashflowCalculation: string;
   cashflowType: CashflowTypeEnum;
   cashflowAmount: IMoney;
   id: string;
   discountFactor: number;
   presentValueAmount: IMoney;
   premiumExpression: IPremiumExpression;
   paymentDiscounting: IPaymentDiscounting;
   payerReceiver: IPayerReceiver;
}

export interface INaturalPersonRole extends IConcept {
   role: NaturalPersonRoleEnum;
   personReference: string;
   roleScheme: string;
}

export interface INaturalPersonRoleBuilder extends IConcept {
   role: NaturalPersonRoleEnum;
   personReference: string;
   roleScheme: string;
}

export enum QuantityTypeEnum {
   UNITS = 'UNITS',
   CONTRACTS = 'CONTRACTS',
   UNITS_OF_MEASURE_PER_TIME_UNIT = 'UNITS_OF_MEASURE_PER_TIME_UNIT',
}

export enum EntityTypeEnum {
   ASIAN = 'ASIAN',
   AUSTRALIAN_AND_NEW_ZEALAND = 'AUSTRALIAN_AND_NEW_ZEALAND',
   EUROPEAN_EMERGING_MARKETS = 'EUROPEAN_EMERGING_MARKETS',
   JAPANESE = 'JAPANESE',
   NORTH_AMERICAN_HIGH_YIELD = 'NORTH_AMERICAN_HIGH_YIELD',
   NORTH_AMERICAN_INSURANCE = 'NORTH_AMERICAN_INSURANCE',
   NORTH_AMERICAN_INVESTMENT_GRADE = 'NORTH_AMERICAN_INVESTMENT_GRADE',
   SINGAPOREAN = 'SINGAPOREAN',
   WESTERN_EUROPEAN = 'WESTERN_EUROPEAN',
   WESTERN_EUROPEAN_INSURANCE = 'WESTERN_EUROPEAN_INSURANCE',
}

export interface IFxFixingDate extends IConcept {
   businessDayConvention: BusinessDayConventionEnum;
   businessCenters: IBusinessCenters;
   businessCentersReference: string;
   dateRelativeToPaymentDates: IDateRelativeToPaymentDates;
   dateRelativeToCalculationPeriodDates: IDateRelativeToCalculationPeriodDates;
   dayType: DayTypeEnum;
   id: string;
   period: PeriodEnum;
   periodMultiplier: number;
}

export interface IFxFixingDateBuilder extends IConcept {
   businessDayConvention: BusinessDayConventionEnum;
   businessCentersReference: string;
   dayType: DayTypeEnum;
   id: string;
   period: PeriodEnum;
   periodMultiplier: number;
}

export interface IRelatedParty extends IConcept {
   role: PartyRoleEnum;
   accountReference: string;
   partyReference: string;
}

export interface IRelatedPartyBuilder extends IConcept {
   role: PartyRoleEnum;
   accountReference: string;
   partyReference: string;
}

export interface ISimplePayment extends IConcept {
   id: string;
   paymentDate: IAdjustableOrRelativeDate;
   paymentAmount: IMoney;
   payerPartyReference: string;
   receiverPartyReference: string;
   payerAccountReference: string;
   receiverAccountReference: string;
}

export interface ISimplePaymentBuilder extends IConcept {
   id: string;
   payerPartyReference: string;
   receiverPartyReference: string;
   payerAccountReference: string;
   receiverAccountReference: string;
}

export enum ResetRelativeToEnum {
   CALCULATION_PERIOD_START_DATE = 'CALCULATION_PERIOD_START_DATE',
   CALCULATION_PERIOD_END_DATE = 'CALCULATION_PERIOD_END_DATE',
}

export interface IProduct extends IConcept {
   listedProduct: IListedProduct;
   contractualProduct: IContractualProduct;
}

export interface IProductBuilder extends IConcept {
}

export interface IResetDates extends IConcept {
   id: string;
   rateCutOffDaysOffset: IOffset;
   resetRelativeTo: ResetRelativeToEnum;
   initialFixingDate: IInitialFixingDate;
   finalFixingDate: IAdjustableDate;
   fixingDates: IRelativeDateOffset;
   calculationPeriodDatesReference: string;
   resetFrequency: IResetFrequency;
   resetDatesAdjustments: IBusinessDayAdjustments;
}

export interface IResetDatesBuilder extends IConcept {
   id: string;
   resetRelativeTo: ResetRelativeToEnum;
   calculationPeriodDatesReference: string;
}

export interface INotDomesticCurrencyBuilder extends IConcept {
   currency: string;
   applicable: boolean;
   currencyScheme: string;
}

export interface INotDomesticCurrency extends IConcept {
   currency: string;
   applicable: boolean;
   currencyScheme: string;
}

export interface IAdjustableOrRelativeDate extends IConcept {
   id: string;
   adjustableDate: IAdjustableDate;
   relativeDate: IRelativeDateOffset;
}

export interface IAdjustableOrRelativeDateBuilder extends IConcept {
   id: string;
}

export enum FraDiscountingEnum {
   ISDA = 'ISDA',
   AFMA = 'AFMA',
   NONE = 'NONE',
   ISDA_YIELD = 'ISDA_YIELD',
}

export interface IFxLinkedNotionalScheduleBuilder extends IConcept {
   varyingNotionalCurrency: string;
   constantNotionalScheduleReference: string;
   initialValue: number;
   varyingNotionalCurrencyScheme: string;
}

export interface IFxLinkedNotionalSchedule extends IConcept {
   varyingNotionalCurrency: string;
   fxSpotRateSource: IFxSpotRateSource;
   constantNotionalScheduleReference: string;
   varyingNotionalFixingDates: IRelativeDateOffset;
   varyingNotionalInterimExchangePaymentDates: IRelativeDateOffset;
   initialValue: number;
   varyingNotionalCurrencyScheme: string;
}

export interface IMultipleExercise extends IConcept {
   maximumNumberOfOptions: number;
   maximumNotionalAmount: number;
   minimumNumberOfOptions: number;
   notionaReference: string;
   integralMultipleAmount: number;
   minimumNotionalAmount: number;
}

export interface IMultipleExerciseBuilder extends IConcept {
   maximumNumberOfOptions: number;
   maximumNotionalAmount: number;
   minimumNumberOfOptions: number;
   notionaReference: string;
   integralMultipleAmount: number;
   minimumNotionalAmount: number;
}

export interface IPCDeliverableObligationCharacBuilder extends IConcept {
   applicable: boolean;
   partialCashSettlement: boolean;
}

export interface IPCDeliverableObligationCharac extends IConcept {
   applicable: boolean;
   partialCashSettlement: boolean;
}

export interface IFloatingAmountProvisions extends IConcept {
   wacCapInterestProvision: boolean;
   stepUpProvision: boolean;
}

export interface IFloatingAmountProvisionsBuilder extends IConcept {
   wacCapInterestProvision: boolean;
   stepUpProvision: boolean;
}

export enum DayTypeEnum {
   BUSINESS = 'BUSINESS',
   CALENDAR = 'CALENDAR',
   COMMODITY_BUSINESS = 'COMMODITY_BUSINESS',
   CURRENCY_BUSINESS = 'CURRENCY_BUSINESS',
   EXCHANGE_BUSINESS = 'EXCHANGE_BUSINESS',
   SCHEDULED_TRADING_DAY = 'SCHEDULED_TRADING_DAY',
}

export interface IFallbackReferencePrice extends IConcept {
   fallBackSettlementRateOption: SettlementRateOptionEnum[];
   fallbackSurveyValuationPostponement: boolean;
   calculationAgenDetermination: ICalculationAgent;
   valuationPostponement: IValuationPostponement;
   fallBackSettlementRateOptionScheme: string;
}

export interface IFallbackReferencePriceBuilder extends IConcept {
   fallBackSettlementRateOption: SettlementRateOptionEnum[];
   fallbackSurveyValuationPostponement: boolean;
   fallBackSettlementRateOptionScheme: string;
}

export interface IFixedIncomeSecurityBuilder extends IConcept {
   couponTypeScheme: string;
   seniorityScheme: string;
   issuerName: string;
   issuerReference: string;
   seniority: CreditSeniorityEnum;
   couponType: CouponTypeEnum;
   couponRate: number;
   maturity: Date;
   issueDate: Date;
   id: string;
   currency: string;
   clearanceSystemScheme: string;
   productIdentifierScheme: string;
   description: string;
   clearanceSystem: string;
   currencyScheme: string;
}

export interface IFixedIncomeSecurity extends IConcept {
   couponTypeScheme: string;
   seniorityScheme: string;
   issuerName: string;
   issuerReference: string;
   seniority: CreditSeniorityEnum;
   couponType: CouponTypeEnum;
   couponRate: number;
   maturity: Date;
   issueDate: Date;
   id: string;
   currency: string;
   clearanceSystemScheme: string;
   productIdentifierScheme: string;
   productIdentifier: IProductIdentifier[];
   productTaxonomy: IProductTaxonomy[];
   description: string;
   clearanceSystem: string;
   currencyScheme: string;
}

export interface IBasketName extends IConcept {
   basketName: string;
   basketId: string[];
   basketIdScheme: string;
   basketNameScheme: string;
}

export interface IBasketNameBuilder extends IConcept {
   basketName: string;
   basketId: string[];
   basketIdScheme: string;
   basketNameScheme: string;
}

export enum QuotationSideEnum {
   BID = 'BID',
   ASK = 'ASK',
   MID = 'MID',
}

export interface ITransferorTransfereeBuilder extends IConcept {
   transferorPartyReference: string;
   transferorAccountReference: string;
   transfereePartyReference: string;
   transfereeAccountReference: string;
}

export interface ITransferorTransferee extends IConcept {
   transferorPartyReference: string;
   transferorAccountReference: string;
   transfereePartyReference: string;
   transfereeAccountReference: string;
}

export interface IFutureValueAmount extends IConcept {
   valueDate: Date;
   calculationPeriodNumberOfDays: number;
   id: string;
   currency: string;
   currencyScheme: string;
   amount: number;
}

export interface IFutureValueAmountBuilder extends IConcept {
   valueDate: Date;
   calculationPeriodNumberOfDays: number;
   id: string;
   currency: string;
   currencyScheme: string;
   amount: number;
}

export enum ObligationCategoryEnum {
   PAYMENT = 'PAYMENT',
   BORROWED_MONEY = 'BORROWED_MONEY',
   REFERENCE_OBLIGATIONS_ONLY = 'REFERENCE_OBLIGATIONS_ONLY',
   BOND = 'BOND',
   LOAN = 'LOAN',
   BOND_OR_LOAN = 'BOND_OR_LOAN',
}

export interface IPhysicalSettlementTerms extends IConcept {
   id: string;
   deliverableObligations: IDeliverableObligations;
   settlementCurrency: string;
   physicalSettlementPeriod: IPhysicalSettlementPeriod;
   escrow: boolean;
   sixtyBusinessDaySettlementCap: boolean;
   settlementCurrencyScheme: string;
}

export interface IPhysicalSettlementTermsBuilder extends IConcept {
   id: string;
   settlementCurrency: string;
   escrow: boolean;
   sixtyBusinessDaySettlementCap: boolean;
   settlementCurrencyScheme: string;
}

export interface IOptionalEarlyTerminationAdjustedDates extends IConcept {
   earlyTerminationEvent: IEarlyTerminationEvent[];
}

export interface IOptionalEarlyTerminationAdjustedDatesBuilder extends IConcept {
}

export interface IOptionSettlement extends IConcept {
   physicalSettlementTerms: IOptionPhysicalSettlement;
   settlementCurrency: string;
   cashSettlementTerms: IOptionCashSettlement;
   settlementType: SettlementTypeEnum;
   settlementDate: IAdjustableOrRelativeDate;
   settlementAmount: IMoney;
   settlementCurrencyScheme: string;
}

export interface IOptionSettlementBuilder extends IConcept {
   settlementCurrency: string;
   settlementType: SettlementTypeEnum;
   settlementCurrencyScheme: string;
}

export interface IOptionalEarlyTermination extends IConcept {
   cashSettlement: IOptionCashSettlement;
   followUpConfirmation: boolean;
   singlePartyOption: IBuyerSeller;
   americanExercise: IAmericanExercise;
   bermudaExercise: IBermudaExercise;
   europeanExercise: IEuropeanExercise;
   exerciseNotice: IExerciseNotice[];
   optionalEarlyTerminationAdjustedDates: IOptionalEarlyTerminationAdjustedDates;
   calculationAgent: ICalculationAgent;
}

export interface IOptionalEarlyTerminationBuilder extends IConcept {
   followUpConfirmation: boolean;
}

export interface IAssetBuilder extends IConcept {
}

export interface IAsset extends IConcept {
   commodity: ICommodity;
   listedProduct: IListedProduct;
}

export enum StubPeriodTypeEnum {
   SHORT_INITIAL = 'SHORT_INITIAL',
   SHORT_FINAL = 'SHORT_FINAL',
   LONG_INITIAL = 'LONG_INITIAL',
   LONG_FINAL = 'LONG_FINAL',
}

export interface IPartyContractInformationBuilder extends IConcept {
   partyReference: string;
}

export interface IPartyContractInformation extends IConcept {
   naturalPersonRole: INaturalPersonRole[];
   partyReference: string;
}

export interface IFxSpotRateSource extends IConcept {
   primaryRateSource: IInformationSource;
   secondaryRateSource: IInformationSource;
   fixingTime: IBusinessCenterTime;
}

export interface IFxSpotRateSourceBuilder extends IConcept {
}

export interface ISettlementRateSource extends IConcept {
   cashSettlementReferenceBanks: ICashSettlementReferenceBanks;
   informationSource: IInformationSource;
}

export interface ISettlementRateSourceBuilder extends IConcept {
}

export interface ICalculationPeriodBuilder extends IConcept {
   id: string;
   notionalAmount: number;
   forecastRate: number;
   unadjustedStartDate: Date;
   unadjustedEndDate: Date;
   adjustedStartDate: Date;
   adjustedEndDate: Date;
   dayCountYearFraction: number;
   calculationPeriodNumberOfDays: number;
   fixedRate: number;
}

export interface ICalculationPeriod extends IConcept {
   id: string;
   notionalAmount: number;
   forecastRate: number;
   unadjustedStartDate: Date;
   unadjustedEndDate: Date;
   adjustedStartDate: Date;
   adjustedEndDate: Date;
   fxLinkedNotionalAmount: IFxLinkedNotionalAmount;
   floatingRateDefinition: IFloatingRateDefinition;
   dayCountYearFraction: number;
   forecastAmount: IMoney;
   calculationPeriodNumberOfDays: number;
   fixedRate: number;
}

export interface IExecutionReferenceBuilder extends IConcept {
   state: StateEnum;
}

export interface IExecutionReference extends IConcept {
   state: StateEnum;
   executionReference: IIdentifier;
}

export interface IExerciseProcedure extends IConcept {
   manualExercise: IManualExercise;
   automaticExercise: IAutomaticExercise;
   followUpConfirmation: boolean;
   limitedRightToConfirm: boolean;
   splitTicket: boolean;
}

export interface IExerciseProcedureBuilder extends IConcept {
   followUpConfirmation: boolean;
   limitedRightToConfirm: boolean;
   splitTicket: boolean;
}

export enum CalculationAgentPartyEnum {
   EXERCISING_PARTY = 'EXERCISING_PARTY',
   NON_EXERCISING_PARTY = 'NON_EXERCISING_PARTY',
   AS_SPECIFIED_IN_MASTER_AGREEMENT = 'AS_SPECIFIED_IN_MASTER_AGREEMENT',
   AS_SPECIFIED_IN_STANDARD_TERMS_SUPPLEMENT = 'AS_SPECIFIED_IN_STANDARD_TERMS_SUPPLEMENT',
   BOTH = 'BOTH',
}

export interface INonNegativeSchedule extends IConcept {
   id: string;
   initialValue: number;
   step: INonNegativeStep[];
}

export interface INonNegativeScheduleBuilder extends IConcept {
   id: string;
   initialValue: number;
}

export interface IContract extends IConcept {
   id: string;
   state: StateEnum;
   account: IAccount[];
   calculationAgent: ICalculationAgent;
   clearedDate: Date;
   collateral: ICollateral;
   contractIdentifier: IPartyContractIdentifier[];
   contractualProduct: IContractualProduct;
   documentation: IDocumentation;
   governingLaw: GoverningLawEnum;
   governingLawScheme: string;
   otherPartyPayment: IPayment[];
   party: IParty[];
   partyContractInformation: IPartyContractInformation[];
   partyRole: IPartyRole[];
   tradeDate: IDateInstances;
   rosettaKey: string;
}

export interface IContractBuilder extends IConcept {
   id: string;
   state: StateEnum;
   clearedDate: Date;
   governingLaw: GoverningLawEnum;
   governingLawScheme: string;
}

export enum DiscountingTypeEnum {
   STANDARD = 'STANDARD',
   FRA = 'FRA',
   FRA_YIELD = 'FRA_YIELD',
}

export interface IMoney extends IConcept {
   id: string;
   currency: string;
   currencyScheme: string;
   amount: number;
}

export interface IMoneyBuilder extends IConcept {
   id: string;
   currency: string;
   currencyScheme: string;
   amount: number;
}

export interface ITriggerEvent extends IConcept {
   triggerDates: IDateList;
   trigger: ITrigger;
   featurePayment: IFeaturePayment;
   schedule: IAveragingSchedule[];
}

export interface ITriggerEventBuilder extends IConcept {
}

export interface IResetFrequencyBuilder extends IConcept {
   weeklyRollConvention: WeeklyRollConventionEnum;
   id: string;
   period: PeriodExtendedEnum;
   periodMultiplier: number;
}

export interface IResetFrequency extends IConcept {
   weeklyRollConvention: WeeklyRollConventionEnum;
   id: string;
   period: PeriodExtendedEnum;
   periodMultiplier: number;
}

export enum TriggerTypeEnum {
   EQUAL_OR_LESS = 'EQUAL_OR_LESS',
   EQUAL_OR_GREATER = 'EQUAL_OR_GREATER',
   EQUAL = 'EQUAL',
   LESS = 'LESS',
   GREATER = 'GREATER',
}

export interface ICashSettlementReferenceBanks extends IConcept {
   referenceBank: IReferenceBank[];
}

export interface ICashSettlementReferenceBanksBuilder extends IConcept {
}

export interface IAssetPoolBuilder extends IConcept {
   effectiveDate: Date;
   initialFactor: number;
   currentFactor: number;
   version: string;
}

export interface IAssetPool extends IConcept {
   effectiveDate: Date;
   initialFactor: number;
   currentFactor: number;
   version: string;
}

export interface IContractualProductBuilder extends IConcept {
}

export interface IContractualProduct extends IConcept {
   economicTerms: IEconomicTerms;
   productTaxonomy: IProductTaxonomy[];
   productIdentification: IProductIdentification;
}

export interface IOptionPayoutBuilder extends IConcept {
   id: string;
   optionType: OptionTypeEnum;
}

export interface IOptionPayout extends IConcept {
   id: string;
   rosettaKeyValue: string;
   buyerSeller: IBuyerSeller;
   optionType: OptionTypeEnum;
   feature: IOptionFeature;
   denomination: IOptionDenomination;
   exerciseTerms: IOptionExercise;
   underlyer: IProduct;
   quantity: IContractualQuantity;
}

export interface IPayoutBuilder extends IConcept {
}

export interface IPayout extends IConcept {
   cashflow: ICashflow[];
   optionPayout: IOptionPayout[];
   creditDefaultPayout: ICreditDefaultPayout;
   interestRatePayout: IInterestRatePayout[];
}

export interface IWeightedAveragingObservation extends IConcept {
   dateTime: Date;
   weight: number;
   observationNumber: number;
}

export interface IWeightedAveragingObservationBuilder extends IConcept {
   dateTime: Date;
   weight: number;
   observationNumber: number;
}

export interface IPubliclyAvailableInformation extends IConcept {
   specifiedNumber: number;
   standardPublicSources: boolean;
   publicSource: string[];
}

export interface IPubliclyAvailableInformationBuilder extends IConcept {
   specifiedNumber: number;
   standardPublicSources: boolean;
   publicSource: string[];
}

export interface IParty extends IConcept {
   id: string;
   partyIdScheme: string;
   partyId: string[];
   legalEntity: ILegalEntity;
   naturalPerson: INaturalPerson[];
}

export interface IPartyBuilder extends IConcept {
   id: string;
   partyIdScheme: string;
   partyId: string[];
}

export interface IMessageInformationBuilder extends IConcept {
   copyToScheme: string;
   messageIdScheme: string;
   sentByScheme: string;
   sentToScheme: string;
   messageId: string;
   sentBy: string;
   sentTo: string;
   copyTo: string[];
}

export interface IMessageInformation extends IConcept {
   copyToScheme: string;
   messageIdScheme: string;
   sentByScheme: string;
   sentToScheme: string;
   messageId: string;
   sentBy: string;
   sentTo: string;
   copyTo: string[];
}

export interface IAsian extends IConcept {
   averagingInOut: AveragingInOutEnum;
   strikeFactor: number;
   averagingPeriodIn: IAveragingPeriod;
   averagingPeriodOut: IAveragingPeriod;
}

export interface IAsianBuilder extends IConcept {
   averagingInOut: AveragingInOutEnum;
   strikeFactor: number;
}

export interface IReferenceBankBuilder extends IConcept {
   referenceBankId: string;
   referenceBankName: string;
   referenceBankIdScheme: string;
}

export interface IReferenceBank extends IConcept {
   referenceBankId: string;
   referenceBankName: string;
   referenceBankIdScheme: string;
}

export interface IProtectionTerms extends IConcept {
   id: string;
   notionalAmount: IMoney;
   creditEvents: ICreditEvents;
   floatingAmountEvents: IFloatingAmountEvents;
   obligations: IObligations;
}

export interface IProtectionTermsBuilder extends IConcept {
   id: string;
}

export enum ProductIdSourceEnum {
   CUSIP = 'CUSIP',
   SEDOL = 'SEDOL',
   ISIN = 'ISIN',
   RIC = 'RIC',
   FIGI = 'FIGI',
   WERTPAPIER = 'WERTPAPIER',
   SICOVAM = 'SICOVAM',
}

export interface IRestructuringBuilder extends IConcept {
   multipleHolderObligation: boolean;
   multipleCreditEventNotices: boolean;
   applicable: boolean;
   restructuringType: RestructuringEnum;
   restructuringTypeScheme: string;
}

export interface IRestructuring extends IConcept {
   multipleHolderObligation: boolean;
   multipleCreditEventNotices: boolean;
   applicable: boolean;
   restructuringType: RestructuringEnum;
   restructuringTypeScheme: string;
}

export interface ICreditEventNotice extends IConcept {
   notifyingParty: INotifyingParty;
   businessCenter: BusinessCenterEnum;
   publiclyAvailableInformation: IPubliclyAvailableInformation;
}

export interface ICreditEventNoticeBuilder extends IConcept {
   businessCenter: BusinessCenterEnum;
}

export interface IStrikeSpread extends IConcept {
   upperStrike: IOptionStrike;
   upperStrikeNumberOfOptions: number;
}

export interface IStrikeSpreadBuilder extends IConcept {
   upperStrikeNumberOfOptions: number;
}

export interface IResourceLength extends IConcept {
   lengthUnit: LengthUnitEnum;
   lengthValue: number;
}

export interface IResourceLengthBuilder extends IConcept {
   lengthUnit: LengthUnitEnum;
   lengthValue: number;
}

export enum ResourceTypeEnum {
   CONFIRMATION = 'CONFIRMATION',
   SUPPLEMENTAL_MATERIAL_ECONOMIC_TERMS = 'SUPPLEMENTAL_MATERIAL_ECONOMIC_TERMS',
   TERM_SHEET = 'TERM_SHEET',
}

export interface IAmericanExerciseBuilder extends IConcept {
   id: string;
}

export interface IAmericanExercise extends IConcept {
   id: string;
   expirationDate: IAdjustableOrRelativeDate;
   relevantUnderlyingDate: IAdjustableOrRelativeDates;
   earliestExerciseTime: IBusinessCenterTime;
   expirationTime: IBusinessCenterTime;
   latestExerciseTime: IBusinessCenterTime;
   multipleExercise: IMultipleExercise;
   exerciseFeeSchedule: IExerciseFeeSchedule;
   commencementDate: IAdjustableOrRelativeDate;
}

export enum CouponTypeEnum {
   FIXED = 'FIXED',
   FLOAT = 'FLOAT',
   STRUCTURED = 'STRUCTURED',
}

export enum SettlementTypeEnum {
   CASH = 'CASH',
   PHYSICAL = 'PHYSICAL',
   ELECTION = 'ELECTION',
   CASH_OR_PHYSICAL = 'CASH_OR_PHYSICAL',
}

export interface ICreditEvents extends IConcept {
   id: string;
   creditEventNotice: ICreditEventNotice;
   restructuring: IRestructuring;
   failureToPayPrincipal: boolean;
   failureToPayInterest: boolean;
   distressedRatingsDowngrade: boolean;
   maturityExtension: boolean;
   writedown: boolean;
   impliedWritedown: boolean;
   bankruptcy: boolean;
   obligationDefault: boolean;
   obligationAcceleration: boolean;
   repudiationMoratorium: boolean;
   governmentalIntervention: boolean;
   failureToPay: IFailureToPay;
   defaultRequirement: IMoney;
}

export interface ICreditEventsBuilder extends IConcept {
   id: string;
   failureToPayPrincipal: boolean;
   failureToPayInterest: boolean;
   distressedRatingsDowngrade: boolean;
   maturityExtension: boolean;
   writedown: boolean;
   impliedWritedown: boolean;
   bankruptcy: boolean;
   obligationDefault: boolean;
   obligationAcceleration: boolean;
   repudiationMoratorium: boolean;
   governmentalIntervention: boolean;
}

export interface INotifyingParty extends IConcept {
   sellerPartyReference: string;
   buyerPartyReference: string;
}

export interface INotifyingPartyBuilder extends IConcept {
   sellerPartyReference: string;
   buyerPartyReference: string;
}

export interface IIndependentAmount extends IConcept {
   paymentDetail: IPaymentDetail[];
   payerPartyReference: string;
   receiverPartyReference: string;
   payerAccountReference: string;
   receiverAccountReference: string;
}

export interface IIndependentAmountBuilder extends IConcept {
   payerPartyReference: string;
   receiverPartyReference: string;
   payerAccountReference: string;
   receiverAccountReference: string;
}

export interface IContractIdentifierBuilder extends IConcept {
   accountReference: string;
   partyReference: string;
   issuer: string;
   issuerScheme: string;
   version: number;
}

export interface IContractIdentifier extends IConcept {
   accountReference: string;
   partyReference: string;
   identifierValue: IIdentifierValue;
   issuer: string;
   issuerScheme: string;
   version: number;
}

export interface IContractualQuantityBuilder extends IConcept {
   notionalReference: string;
}

export interface IContractualQuantity extends IConcept {
   notionalAmount: IMoney;
   notionalSchedule: INotionalSchedule;
   fxLinkedNotional: IFxLinkedNotionalSchedule;
   notionalReference: string;
   quantity: IQuantity;
   futureValueNotional: IFutureValueAmount;
}

export interface IDateRelativeToPaymentDates extends IConcept {
   paymentDatesReference: string[];
}

export interface IDateRelativeToPaymentDatesBuilder extends IConcept {
   paymentDatesReference: string[];
}

export interface IPaymentCalculationPeriod extends IConcept {
   id: string;
   unadjustedPaymentDate: Date;
   adjustedPaymentDate: Date;
   fixedPaymentAmount: number;
   discountFactor: number;
   forecastPaymentAmount: IMoney;
   presentValueAmount: IMoney;
   calculationPeriod: ICalculationPeriod[];
}

export interface IPaymentCalculationPeriodBuilder extends IConcept {
   id: string;
   unadjustedPaymentDate: Date;
   adjustedPaymentDate: Date;
   fixedPaymentAmount: number;
   discountFactor: number;
}

export interface IPartialExercise extends IConcept {
   minimumNumberOfOptions: number;
   notionaReference: string;
   integralMultipleAmount: number;
   minimumNotionalAmount: number;
}

export interface IPartialExerciseBuilder extends IConcept {
   minimumNumberOfOptions: number;
   notionaReference: string;
   integralMultipleAmount: number;
   minimumNotionalAmount: number;
}

export enum MortgageSectorEnum {
   ABS = 'ABS',
   CDO = 'CDO',
   CMBS = 'CMBS',
   RMBS = 'RMBS',
}

export interface ICrossCurrencyTerms extends IConcept {
   settlementProvision: ISettlementProvision;
   principalExchanges: IPrincipalExchanges;
}

export interface ICrossCurrencyTermsBuilder extends IConcept {
}

export enum PartyIdSourceEnum {
   BIC = 'BIC',
   LEI = 'LEI',
   ARNU = 'ARNU',
   CCPT = 'CCPT',
   CUST = 'CUST',
   DRLC = 'DRLC',
   EMPL = 'EMPL',
   NIDN = 'NIDN',
   SOSE = 'SOSE',
   TXID = 'TXID',
}

export interface IIssuerTradeId extends IConcept {
   identifier: string;
   issuer: string;
   issuerScheme: string;
   identifierScheme: string;
}

export interface IIssuerTradeIdBuilder extends IConcept {
   identifier: string;
   issuer: string;
   issuerScheme: string;
   identifierScheme: string;
}

export interface IIdentifierBuilder extends IConcept {
   issuer: string;
   issuerScheme: string;
   version: number;
}

export interface IIdentifier extends IConcept {
   identifierValue: IIdentifierValue;
   issuer: string;
   issuerScheme: string;
   version: number;
}

export interface IFrequencyBuilder extends IConcept {
   id: string;
   period: PeriodExtendedEnum;
   periodMultiplier: number;
}

export interface IFrequency extends IConcept {
   id: string;
   period: PeriodExtendedEnum;
   periodMultiplier: number;
}

export interface IPassThroughItem extends IConcept {
   passThroughPercentage: number;
   payerReceiver: IPayerReceiver;
}

export interface IPassThroughItemBuilder extends IConcept {
   passThroughPercentage: number;
}

export interface IOtherAgreementBuilder extends IConcept {
   type: string;
   identifier: string;
   identifierScheme: string;
   date: Date;
   typeScheme: string;
   versionScheme: string;
   version: string;
}

export interface IOtherAgreement extends IConcept {
   type: string;
   identifier: string;
   identifierScheme: string;
   date: Date;
   typeScheme: string;
   versionScheme: string;
   version: string;
}

export enum ContractualSupplementEnum {
   ABX = 'ABX',
   CD_SON_MBS = 'CD_SON_MBS',
   ISDA_1999_CREDIT_CONVERTIBLE_EXCHANGEABLE_ACCRETING_OBLIGATIONS = 'ISDA_1999_CREDIT_CONVERTIBLE_EXCHANGEABLE_ACCRETING_OBLIGATIONS',
   ISDA_1999_CREDIT_SUCCESSOR_AND_CREDIT_EVENTS = 'ISDA_1999_CREDIT_SUCCESSOR_AND_CREDIT_EVENTS',
   ISDA_2003_CREDIT_MAY_2003 = 'ISDA_2003_CREDIT_MAY_2003',
   I_TRAXX_EUROPE_DEALER = 'I_TRAXX_EUROPE_DEALER',
   STANDARD_LCDS = 'STANDARD_LCDS',
}

export enum TaxonomySourceEnum {
   CFI = 'CFI',
   ISDA = 'ISDA',
}

export interface IFailureToPay extends IConcept {
   applicable: boolean;
   gracePeriodExtension: IGracePeriodExtension;
   paymentRequirement: IMoney;
}

export interface IFailureToPayBuilder extends IConcept {
   applicable: boolean;
}

export enum PayRelativeToEnum {
   CALCULATION_PERIOD_START_DATE = 'CALCULATION_PERIOD_START_DATE',
   CALCULATION_PERIOD_END_DATE = 'CALCULATION_PERIOD_END_DATE',
   LAST_PRICING_DATE = 'LAST_PRICING_DATE',
   RESET_DATE = 'RESET_DATE',
   VALUATION_DATE = 'VALUATION_DATE',
}

export interface IExerciseEventBuilder extends IConcept {
   id: string;
   adjustedRelevantSwapEffectiveDate: Date;
   adjustedExerciseFeePaymentDate: Date;
   adjustedCashSettlementValuationDate: Date;
   adjustedCashSettlementPaymentDate: Date;
   adjustedExerciseDate: Date;
}

export interface IExerciseEvent extends IConcept {
   id: string;
   adjustedRelevantSwapEffectiveDate: Date;
   adjustedExerciseFeePaymentDate: Date;
   adjustedCashSettlementValuationDate: Date;
   adjustedCashSettlementPaymentDate: Date;
   adjustedExerciseDate: Date;
}

export interface ISpreadSchedule extends IConcept {
   type: SpreadScheduleTypeEnum;
   typeScheme: string;
   id: string;
   initialValue: number;
   step: IStep[];
}

export interface ISpreadScheduleBuilder extends IConcept {
   type: SpreadScheduleTypeEnum;
   typeScheme: string;
   id: string;
   initialValue: number;
}

export interface ILoanParticipation extends IConcept {
   qualifyingParticipationSeller: string;
   applicable: boolean;
   partialCashSettlement: boolean;
}

export interface ILoanParticipationBuilder extends IConcept {
   qualifyingParticipationSeller: string;
   applicable: boolean;
   partialCashSettlement: boolean;
}

export interface IIdentifierValueBuilder extends IConcept {
   id: string;
   identifier: string;
   identifierScheme: string;
}

export interface IIdentifierValue extends IConcept {
   id: string;
   identifier: string;
   identifierScheme: string;
}

export interface ILoan extends IConcept {
   facilityTypeScheme: string;
   lienScheme: string;
   trancheScheme: string;
   tranche: string;
   maturity: Date;
   borrower: ILegalEntity[];
   borrowerReference: string[];
   lien: string;
   facilityType: string;
   creditAgreementDate: Date;
   id: string;
   instrumentIdentifierScheme: string;
   description: string;
   instrumentIdentifier: string[];
}

export interface ILoanBuilder extends IConcept {
   facilityTypeScheme: string;
   lienScheme: string;
   trancheScheme: string;
   tranche: string;
   maturity: Date;
   borrowerReference: string[];
   lien: string;
   facilityType: string;
   creditAgreementDate: Date;
   id: string;
   instrumentIdentifierScheme: string;
   description: string;
   instrumentIdentifier: string[];
}

export interface IEventEffect extends IConcept {
   listedProduct: string[];
   payment: string[];
   contractReference: string[];
   effectedContract: string[];
   effectedContractReference: string[];
   effectedEvent: string;
   transfer: string[];
   contract: string[];
}

export interface IEventEffectBuilder extends IConcept {
   listedProduct: string[];
   payment: string[];
   contractReference: string[];
   effectedContract: string[];
   effectedContractReference: string[];
   effectedEvent: string;
   transfer: string[];
   contract: string[];
}

export interface IBusinessCentersBuilder extends IConcept {
   id: string;
   businessCenterScheme: string;
   businessCenter: BusinessCenterEnum[];
   businessCentersReference: string;
}

export interface IBusinessCenters extends IConcept {
   id: string;
   businessCenterScheme: string;
   businessCenter: BusinessCenterEnum[];
   businessCentersReference: string;
}

export interface IBondOptionStrikeBuilder extends IConcept {
}

export interface IBondOptionStrike extends IConcept {
   referenceSwapCurve: IReferenceSwapCurve;
   price: IOptionStrike;
}

export interface IMandatoryEarlyTerminationBuilder extends IConcept {
   id: string;
}

export interface IMandatoryEarlyTermination extends IConcept {
   id: string;
   cashSettlement: IOptionCashSettlement;
   calculationAgent: ICalculationAgent;
   mandatoryEarlyTerminationDate: IAdjustableDate;
   mandatoryEarlyTerminationAdjustedDates: IMandatoryEarlyTerminationAdjustedDates;
}

export interface IOptionStyleBuilder extends IConcept {
}

export interface IOptionStyle extends IConcept {
   americanExercise: IAmericanExercise;
   bermudaExercise: IBermudaExercise;
   europeanExercise: IEuropeanExercise;
}

export interface IProductIdentifierBuilder extends IConcept {
   productId: string;
   productIdSource: ProductIdSourceEnum;
   productIdScheme: string;
}

export interface IProductIdentifier extends IConcept {
   productId: string;
   productIdSource: ProductIdSourceEnum;
   productIdScheme: string;
}

export interface ISpecifiedCurrencyBuilder extends IConcept {
   currency: string;
   applicable: boolean;
   currencyScheme: string;
}

export interface ISpecifiedCurrency extends IConcept {
   currency: string;
   applicable: boolean;
   currencyScheme: string;
}

export interface ICalculationPeriodDates extends IConcept {
   id: string;
   calculationPeriodFrequency: ICalculationPeriodFrequency;
   effectiveDate: IDateInstances;
   terminationDate: IAdjustableDate;
   firstCompoundingPeriodEndDate: Date;
   stubPeriodType: StubPeriodTypeEnum;
   relativeEffectiveDate: IAdjustedRelativeDateOffset;
   relativeTerminationDate: IRelativeDateOffset;
   firstPeriodStartDate: IAdjustableDate;
   firstRegularPeriodStartDate: Date;
   calculationPeriodDatesAdjustments: IBusinessDayAdjustments;
   lastRegularPeriodEndDate: Date;
}

export interface ICalculationPeriodDatesBuilder extends IConcept {
   id: string;
   firstCompoundingPeriodEndDate: Date;
   stubPeriodType: StubPeriodTypeEnum;
   firstRegularPeriodStartDate: Date;
   lastRegularPeriodEndDate: Date;
}

export interface IStubCalculationPeriodAmount extends IConcept {
   calculationPeriodDatesReference: string;
   initialStub: IStubValue;
   finalStub: IStubValue;
}

export interface IStubCalculationPeriodAmountBuilder extends IConcept {
   calculationPeriodDatesReference: string;
}

export enum SettledEntityMatrixSourceEnum {
   CONFIRMATION_ANNEX = 'CONFIRMATION_ANNEX',
   NOT_APPLICABLE = 'NOT_APPLICABLE',
   PUBLISHER = 'PUBLISHER',
}

export interface ISwapCurveValuation extends IConcept {
   floatingRateIndex: FloatingRateIndexEnum;
   indexTenor: IPeriod;
   spread: number;
   side: QuotationSideEnum;
}

export interface ISwapCurveValuationBuilder extends IConcept {
   floatingRateIndex: FloatingRateIndexEnum;
   spread: number;
   side: QuotationSideEnum;
}

export interface IPartyAndAccountReferenceBuilder extends IConcept {
   accountReference: string;
   partyReference: string;
}

export interface IPartyAndAccountReference extends IConcept {
   accountReference: string;
   partyReference: string;
}

export interface IConstituentWeightBuilder extends IConcept {
   openUnits: number;
   basketPercentage: number;
}

export interface IConstituentWeight extends IConcept {
   openUnits: number;
   basketPercentage: number;
}

export interface IInterestRatePayoutBuilder extends IConcept {
   id: string;
   dayCountFractionScheme: string;
   dayCountFraction: DayCountFractionEnum;
   compoundingMethod: CompoundingMethodEnum;
}

export interface IInterestRatePayout extends IConcept {
   id: string;
   rosettaKeyValue: string;
   dayCountFractionScheme: string;
   crossCurrencyTerms: ICrossCurrencyTerms;
   discounting: IDiscounting;
   cashflowRepresentation: ICashflowRepresentation;
   bondReference: IBondReference;
   dayCountFraction: DayCountFractionEnum;
   compoundingMethod: CompoundingMethodEnum;
   resetDates: IResetDates;
   payerReceiver: IPayerReceiver;
   calculationPeriodDates: ICalculationPeriodDates;
   quantity: IContractualQuantity;
   interestRate: IInterestRate;
   stubPeriod: IStubPeriod;
   paymentDates: IPaymentDates;
}

export interface IAdjustableOrAdjustedOrRelativeDateBuilder extends IConcept {
   id: string;
   unadjustedDate: Date;
   adjustedDate: Date;
}

export interface IAdjustableOrAdjustedOrRelativeDate extends IConcept {
   id: string;
   unadjustedDate: Date;
   relativeDate: IRelativeDateOffset;
   adjustedDate: Date;
   dateAdjustments: IBusinessDayAdjustments;
}

export interface IObligations extends IConcept {
   category: ObligationCategoryEnum;
   excluded: string;
   fullFaithAndCreditObLiability: boolean;
   generalFundObligationLiability: boolean;
   listed: boolean;
   notContingent: boolean;
   notDomesticCurrency: INotDomesticCurrency;
   notDomesticIssuance: boolean;
   notDomesticLaw: boolean;
   notSovereignLender: boolean;
   notSubordinated: boolean;
   othReferenceEntityObligations: string;
   revenueObligationLiability: boolean;
   specifiedCurrency: ISpecifiedCurrency;
   designatedPriority: string;
   cashSettlementOnly: boolean;
   deliveryOfCommitments: boolean;
   continuity: boolean;
   designatedPriorityScheme: string;
}

export interface IObligationsBuilder extends IConcept {
   category: ObligationCategoryEnum;
   excluded: string;
   fullFaithAndCreditObLiability: boolean;
   generalFundObligationLiability: boolean;
   listed: boolean;
   notContingent: boolean;
   notDomesticIssuance: boolean;
   notDomesticLaw: boolean;
   notSovereignLender: boolean;
   notSubordinated: boolean;
   othReferenceEntityObligations: string;
   revenueObligationLiability: boolean;
   designatedPriority: string;
   cashSettlementOnly: boolean;
   deliveryOfCommitments: boolean;
   continuity: boolean;
   designatedPriorityScheme: string;
}

export interface IContractualTermsSupplement extends IConcept {
   type: ContractualSupplementEnum;
   publicationDate: Date;
   typeScheme: string;
}

export interface IContractualTermsSupplementBuilder extends IConcept {
   type: ContractualSupplementEnum;
   publicationDate: Date;
   typeScheme: string;
}

export interface ILineage extends IConcept {
   contractReference: IIdentifier[];
   eventReference: IIdentifier[];
   contractReferenceScheme: string;
}

export interface ILineageBuilder extends IConcept {
   contractReferenceScheme: string;
}

export interface ISettledEntityMatrix extends IConcept {
   publicationDate: Date;
   matrixSourceScheme: string;
   matrixSource: SettledEntityMatrixSourceEnum;
}

export interface ISettledEntityMatrixBuilder extends IConcept {
   publicationDate: Date;
   matrixSourceScheme: string;
   matrixSource: SettledEntityMatrixSourceEnum;
}

export interface IReferenceInformationBuilder extends IConcept {
   referencePrice: number;
   allGuarantees: boolean;
   noReferenceObligation: boolean;
   unknownReferenceObligation: boolean;
   referencePolicy: boolean;
   securedList: boolean;
}

export interface IReferenceInformation extends IConcept {
   referencePrice: number;
   allGuarantees: boolean;
   referenceObligation: IReferenceObligation[];
   referenceEntity: ILegalEntity;
   noReferenceObligation: boolean;
   unknownReferenceObligation: boolean;
   referencePolicy: boolean;
   securedList: boolean;
}

export interface INonNegativeAmountScheduleBuilder extends IConcept {
   currency: string;
   currencyScheme: string;
   id: string;
   initialValue: number;
}

export interface INonNegativeAmountSchedule extends IConcept {
   currency: string;
   currencyScheme: string;
   id: string;
   initialValue: number;
   step: INonNegativeStep[];
}

export enum CashflowTypeEnum {
   BROKERAGE_COMMISSION = 'BROKERAGE_COMMISSION',
   FEE = 'FEE',
   INTEREST = 'INTEREST',
   NET_INTEREST = 'NET_INTEREST',
   NOVATION_FEE = 'NOVATION_FEE',
   PREMIUM = 'PREMIUM',
   TERMINATION_FEE = 'TERMINATION_FEE',
}

export interface IPayerReceiver extends IConcept {
   payerPartyReference: string;
   receiverPartyReference: string;
   payerAccountReference: string;
   receiverAccountReference: string;
}

export interface IPayerReceiverBuilder extends IConcept {
   payerPartyReference: string;
   receiverPartyReference: string;
   payerAccountReference: string;
   receiverAccountReference: string;
}

export enum BusinessCenterEnum {
   AEAD = 'AEAD',
   AEDU = 'AEDU',
   AMYE = 'AMYE',
   BEBR = 'BEBR',
   BRBD = 'BRBD',
   CATO = 'CATO',
   CHZU = 'CHZU',
   CNBE = 'CNBE',
   DEFR = 'DEFR',
   EUTA = 'EUTA',
   GBLO = 'GBLO',
   INMU = 'INMU',
   JPTO = 'JPTO',
   KRSE = 'KRSE',
   USNY = 'USNY',
}

export interface IBasketReferenceInformation extends IConcept {
   tranche: ITranche;
   basketName: IBasketName;
   basketId: string[];
   referencePool: IReferencePool;
   nthToDefault: number;
   mthToDefault: number;
   basketIdScheme: string;
}

export interface IBasketReferenceInformationBuilder extends IConcept {
   basketId: string[];
   nthToDefault: number;
   mthToDefault: number;
   basketIdScheme: string;
}

export interface IFeaturePayment extends IConcept {
   id: string;
   currency: string;
   featurePaymentDate: IAdjustableOrAdjustedDate;
   currencyScheme: string;
   levelPercentage: number;
   payerReceiver: IPayerReceiver;
   amount: number;
   time: TimeTypeEnum;
}

export interface IFeaturePaymentBuilder extends IConcept {
   id: string;
   currency: string;
   currencyScheme: string;
   levelPercentage: number;
   amount: number;
   time: TimeTypeEnum;
}

export interface IReferencePool extends IConcept {
   referencePoolItem: IReferencePoolItem[];
}

export interface IReferencePoolBuilder extends IConcept {
}

export interface IPhysicalSettlementPeriod extends IConcept {
   businessDays: number;
   maximumBusinessDays: number;
   businessDaysNotSpecified: boolean;
}

export interface IPhysicalSettlementPeriodBuilder extends IConcept {
   businessDays: number;
   maximumBusinessDays: number;
   businessDaysNotSpecified: boolean;
}

export enum PackageTypeEnum {
   BUTTERFLY = 'BUTTERFLY',
   CALENDAR_ROLL = 'CALENDAR_ROLL',
   CALENDAR_SPREAD = 'CALENDAR_SPREAD',
   CUSTOM = 'CUSTOM',
   INDEX_ROLL = 'INDEX_ROLL',
   ONE_CANCELS_OTHERS = 'ONE_CANCELS_OTHERS',
   SWAP_SPREAD = 'SWAP_SPREAD',
   SWITCH = 'SWITCH',
}

export interface IEconomicTermsBuilder extends IConcept {
}

export interface IEconomicTerms extends IConcept {
   rosettaKeyValue: string;
   payout: IPayout;
   earlyTerminationProvision: IEarlyTerminationProvision;
   cancelableProvision: ICancelableProvision;
   extendibleProvision: IExtendibleProvision;
}

export interface IEquityAsset extends IConcept {
   id: string;
   currency: string;
   clearanceSystemScheme: string;
   productIdentifierScheme: string;
   productIdentifier: IProductIdentifier[];
   productTaxonomy: IProductTaxonomy[];
   description: string;
   clearanceSystem: string;
   currencyScheme: string;
}

export interface IEquityAssetBuilder extends IConcept {
   id: string;
   currency: string;
   clearanceSystemScheme: string;
   productIdentifierScheme: string;
   description: string;
   clearanceSystem: string;
   currencyScheme: string;
}

export interface IAdjustableOrRelativeDates extends IConcept {
   id: string;
   adjustableDates: IAdjustableDates;
   relativeDates: IRelativeDates;
}

export interface IAdjustableOrRelativeDatesBuilder extends IConcept {
   id: string;
}

export enum IndexAnnexSourceEnum {
   MASTER_CONFIRMATION = 'MASTER_CONFIRMATION',
   PUBLISHER = 'PUBLISHER',
}

export interface IKnock extends IConcept {
   knockOut: ITriggerEvent;
   knockIn: ITriggerEvent;
}

export interface IKnockBuilder extends IConcept {
}

export interface ICalculationAgentModelBuilder extends IConcept {
   calculationAgentBusinessCenter: BusinessCenterEnum;
}

export interface ICalculationAgentModel extends IConcept {
   calculationAgentBusinessCenter: BusinessCenterEnum;
   calculationAgent: ICalculationAgent;
}

export interface ICalendarSpread extends IConcept {
   expirationDateTwo: IAdjustableOrRelativeDate;
}

export interface ICalendarSpreadBuilder extends IConcept {
}

export interface IProductTaxonomy extends IConcept {
   taxonomyValue: string;
   taxonomySource: TaxonomySourceEnum;
}

export interface IProductTaxonomyBuilder extends IConcept {
   taxonomyValue: string;
   taxonomySource: TaxonomySourceEnum;
}

export enum TransferTypeEnum {
   SECURITY_SETTLEMENT = 'SECURITY_SETTLEMENT',
   SECURITY_TRANSFER = 'SECURITY_TRANSFER',
   BROKERAGE_COMMISSION = 'BROKERAGE_COMMISSION',
   FEE = 'FEE',
   INTEREST = 'INTEREST',
   NET_INTEREST = 'NET_INTEREST',
   NOVATION_FEE = 'NOVATION_FEE',
   PREMIUM = 'PREMIUM',
   TERMINATION_FEE = 'TERMINATION_FEE',
}

export interface IBrokerConfirmation extends IConcept {
   brokerConfirmationType: BrokerConfirmationTypeEnum;
   brokerConfirmationTypeScheme: string;
}

export interface IBrokerConfirmationBuilder extends IConcept {
   brokerConfirmationType: BrokerConfirmationTypeEnum;
   brokerConfirmationTypeScheme: string;
}

export interface IDeliverableObligations extends IConcept {
   category: ObligationCategoryEnum;
   acceleratedOrMatured: boolean;
   accruedInterest: boolean;
   assignableLoan: IPCDeliverableObligationCharac;
   consentRequiredLoan: IPCDeliverableObligationCharac;
   directLoanParticipation: ILoanParticipation;
   excluded: string;
   fullFaithAndCreditObLiability: boolean;
   generalFundObligationLiability: boolean;
   indirectLoanParticipation: ILoanParticipation;
   listed: boolean;
   maximumMaturity: IPeriod;
   notBearer: boolean;
   notContingent: boolean;
   notDomesticCurrency: INotDomesticCurrency;
   notDomesticIssuance: boolean;
   notDomesticLaw: boolean;
   notSovereignLender: boolean;
   notSubordinated: boolean;
   othReferenceEntityObligations: string;
   revenueObligationLiability: boolean;
   specifiedCurrency: ISpecifiedCurrency;
   transferable: boolean;
}

export interface IDeliverableObligationsBuilder extends IConcept {
   category: ObligationCategoryEnum;
   acceleratedOrMatured: boolean;
   accruedInterest: boolean;
   excluded: string;
   fullFaithAndCreditObLiability: boolean;
   generalFundObligationLiability: boolean;
   listed: boolean;
   notBearer: boolean;
   notContingent: boolean;
   notDomesticIssuance: boolean;
   notDomesticLaw: boolean;
   notSovereignLender: boolean;
   notSubordinated: boolean;
   othReferenceEntityObligations: string;
   revenueObligationLiability: boolean;
   transferable: boolean;
}

export interface IDateInstancesBuilder extends IConcept {
   id: string;
   date: Date;
}

export interface IDateInstances extends IConcept {
   id: string;
   adjustableDate: IAdjustableDate;
   priorDateInstance: IPriorDateInstance[];
   date: Date;
}

export interface IExerciseNoticeBuilder extends IConcept {
   businessCenterScheme: string;
   businessCenter: BusinessCenterEnum;
   exerciseNoticePartyReference: string;
   partyReference: string;
}

export interface IExerciseNotice extends IConcept {
   businessCenterScheme: string;
   businessCenter: BusinessCenterEnum;
   exerciseNoticePartyReference: string;
   partyReference: string;
}

export enum MasterAgreementTypeEnum {
   AFB = 'AFB',
   ISDA = 'ISDA',
}

export interface IFloatingRate extends IConcept {
   id: string;
   spreadSchedule: ISpreadSchedule[];
   floatingRateIndexScheme: string;
   floatingRateMultiplierSchedule: ISchedule;
   floatingRateIndex: FloatingRateIndexEnum;
   indexTenor: IPeriod;
   rateTreatment: RateTreatmentEnum;
   capRateSchedule: IStrikeSchedule[];
   floorRateSchedule: IStrikeSchedule[];
}

export interface IFloatingRateBuilder extends IConcept {
   id: string;
   floatingRateIndexScheme: string;
   floatingRateIndex: FloatingRateIndexEnum;
   rateTreatment: RateTreatmentEnum;
}

export interface ICancellationEvent extends IConcept {
   id: string;
   adjustedEarlyTerminationDate: Date;
   adjustedExerciseDate: Date;
}

export interface ICancellationEventBuilder extends IConcept {
   id: string;
   adjustedEarlyTerminationDate: Date;
   adjustedExerciseDate: Date;
}

export interface IMultipleValuationDates extends IConcept {
   businessDaysThereafter: number;
   numberValuationDates: number;
   businessDays: number;
}

export interface IMultipleValuationDatesBuilder extends IConcept {
   businessDaysThereafter: number;
   numberValuationDates: number;
   businessDays: number;
}

export interface ITriggerBuilder extends IConcept {
   level: number;
   levelPercentage: number;
   creditEventsReference: string;
   triggerType: TriggerTypeEnum;
   triggerTimeType: TriggerTimeTypeEnum;
}

export interface ITrigger extends IConcept {
   creditEvents: ICreditEvents;
   level: number;
   levelPercentage: number;
   creditEventsReference: string;
   triggerType: TriggerTypeEnum;
   triggerTimeType: TriggerTimeTypeEnum;
}

export interface IExerciseOutcome extends IConcept {
   physicalExercise: IPhysicalExercise;
   cashExercise: ICashflow;
   contractReference: IContractReference[];
   contract: IContract[];
}

export interface IExerciseOutcomeBuilder extends IConcept {
}

export interface IExerciseFeeScheduleBuilder extends IConcept {
   notionalReference: string;
   payerPartyReference: string;
   receiverPartyReference: string;
   payerAccountReference: string;
   receiverAccountReference: string;
}

export interface IExerciseFeeSchedule extends IConcept {
   notionalReference: string;
   feeAmountSchedule: IAmountSchedule;
   feeRateSchedule: ISchedule;
   feePaymentDate: IRelativeDateOffset;
   payerPartyReference: string;
   receiverPartyReference: string;
   payerAccountReference: string;
   receiverAccountReference: string;
}

export enum MarketDisruptionEnum {
   MODIFIED_POSTPONEMENT = 'MODIFIED_POSTPONEMENT',
   OMISSION = 'OMISSION',
   POSTPONEMENT = 'POSTPONEMENT',
}

export enum FloatingRateIndexEnum {
   AED_EBOR_REUTERS = 'AED_EBOR_REUTERS',
   AUD_AONIA_OIS_COMPOUND = 'AUD_AONIA_OIS_COMPOUND',
   AUD_AONIA_OIS_COMPOUND_SWAP_MARKER = 'AUD_AONIA_OIS_COMPOUND_SWAP_MARKER',
   BRL_CDI = 'BRL_CDI',
   CAD_BA_CDOR = 'CAD_BA_CDOR',
   CNY_CNREPOFIX_CFXS_REUTERS = 'CNY_CNREPOFIX_CFXS_REUTERS',
   EUR_EONIA_OIS_COMPOUND = 'EUR_EONIA_OIS_COMPOUND',
   EUR_EURIBOR_REUTERS = 'EUR_EURIBOR_REUTERS',
   EUR_EURIBOR_TELERATE = 'EUR_EURIBOR_TELERATE',
   EUR_LIBOR_BBA = 'EUR_LIBOR_BBA',
   GBP_LIBOR_BBA = 'GBP_LIBOR_BBA',
   GBP_LIBOR_ISDA = 'GBP_LIBOR_ISDA',
   GBP_SONIA_COMPOUND = 'GBP_SONIA_COMPOUND',
   INR_FBIL_MIBOR_OIS_COMPOUND = 'INR_FBIL_MIBOR_OIS_COMPOUND',
   KRW_CD_KSDA_BLOOMBERG = 'KRW_CD_KSDA_BLOOMBERG',
   UK_RPIX = 'UK_RPIX',
   USA_CPI_U = 'USA_CPI_U',
   USD_FEDERAL_FUNDS_H_15_OIS_COMPOUND = 'USD_FEDERAL_FUNDS_H_15_OIS_COMPOUND',
   USD_LIBOR_BBA = 'USD_LIBOR_BBA',
}

export interface IEventTimestamp extends IConcept {
   expiryTimestamp: Date;
   creationTimestamp: Date;
}

export interface IEventTimestampBuilder extends IConcept {
   expiryTimestamp: Date;
   creationTimestamp: Date;
}

export interface IQuantoBuilder extends IConcept {
}

export interface IQuanto extends IConcept {
   fxRate: IFxRate[];
   fxSpotRateSource: IFxSpotRateSource;
}

export enum UnitEnum {
   M_WH = 'M_WH',
   MMBTU = 'MMBTU',
   BBL = 'BBL',
   GAL = 'GAL',
   BSH = 'BSH',
}

export enum DeterminationMethodEnum {
   AGREED_INITIAL_PRICE = 'AGREED_INITIAL_PRICE',
   AS_SPECIFIED_IN_MASTER_CONFIRMATION = 'AS_SPECIFIED_IN_MASTER_CONFIRMATION',
   CALCULATION_AGENT = 'CALCULATION_AGENT',
   CLOSING_PRICE = 'CLOSING_PRICE',
   DIVIDEND_CURRENCY = 'DIVIDEND_CURRENCY',
   EXPIRING_CONTRACT_LEVEL = 'EXPIRING_CONTRACT_LEVEL',
   HEDGE_EXECUTION = 'HEDGE_EXECUTION',
   ISSUER_PAYMENT_CURRENCY = 'ISSUER_PAYMENT_CURRENCY',
   NAV = 'NAV',
   OPEN_PRICE = 'OPEN_PRICE',
   OSP_PRICE = 'OSP_PRICE',
   SETTLEMENT_CURRENCY = 'SETTLEMENT_CURRENCY',
   STRIKE_DATE_DETERMINATION = 'STRIKE_DATE_DETERMINATION',
   TWAP_PRICE = 'TWAP_PRICE',
   VALUATION_TIME = 'VALUATION_TIME',
   VWAP_PRICE = 'VWAP_PRICE',
}

export interface INotionalSchedule extends IConcept {
   id: string;
   notionalStepSchedule: INonNegativeAmountSchedule;
   notionalStepParameters: INotionalStepRule;
}

export interface INotionalScheduleBuilder extends IConcept {
   id: string;
}

export enum PeriodEnum {
   D = 'D',
   W = 'W',
   M = 'M',
   Y = 'Y',
}

export interface IInceptionBuilder extends IConcept {
}

export interface IInception extends IConcept {
   before: IContractOrContractReference[];
   after: IContractOrContractReference;
}

export interface IExerciseFeeBuilder extends IConcept {
   notionalReference: string;
   feeAmount: number;
   feeRate: number;
   sellerPartyReference: string;
   buyerPartyReference: string;
   buyerAccountReference: string;
   sellerAccountReference: string;
}

export interface IExerciseFee extends IConcept {
   notionalReference: string;
   feePaymentDate: IRelativeDateOffset;
   feeAmount: number;
   feeRate: number;
   sellerPartyReference: string;
   buyerPartyReference: string;
   buyerAccountReference: string;
   sellerAccountReference: string;
}

export enum BusinessDayConventionEnum {
   FOLLOWING = 'FOLLOWING',
   FRN = 'FRN',
   MODFOLLOWING = 'MODFOLLOWING',
   PRECEDING = 'PRECEDING',
   MODPRECEDING = 'MODPRECEDING',
   NEAREST = 'NEAREST',
   NONE = 'NONE',
   NOT_APPLICABLE = 'NOT_APPLICABLE',
}

export interface ICancelableProvisionAdjustedDatesBuilder extends IConcept {
}

export interface ICancelableProvisionAdjustedDates extends IConcept {
   cancellationEvent: ICancellationEvent[];
}

export enum PremiumTypeEnum {
   PRE_PAID = 'PRE_PAID',
   POST_PAID = 'POST_PAID',
   VARIABLE = 'VARIABLE',
   FIXED = 'FIXED',
}

export interface IQuantity extends IConcept {
   unit: UnitEnum;
   amount: number;
}

export interface IQuantityBuilder extends IConcept {
   unit: UnitEnum;
   amount: number;
}

export interface IFinalCalculationPeriodDateAdjustment extends IConcept {
   businessDayConvention: BusinessDayConventionEnum;
   relevantUnderlyingDateReference: string;
   swapStreamReference: string;
}

export interface IFinalCalculationPeriodDateAdjustmentBuilder extends IConcept {
   businessDayConvention: BusinessDayConventionEnum;
   relevantUnderlyingDateReference: string;
   swapStreamReference: string;
}

export interface ICalculationAmount extends IConcept {
   step: IStep[];
   id: string;
   currency: string;
   currencyScheme: string;
   amount: number;
}

export interface ICalculationAmountBuilder extends IConcept {
   id: string;
   currency: string;
   currencyScheme: string;
   amount: number;
}

export enum TriggerTimeTypeEnum {
   CLOSING = 'CLOSING',
   ANYTIME = 'ANYTIME',
}

export interface IEarlyTerminationProvision extends IConcept {
   id: string;
   mandatoryEarlyTerminationDateTenor: IPeriod;
   optionalEarlyTerminationParameters: IExercisePeriod;
   mandatoryEarlyTermination: IMandatoryEarlyTermination;
   optionalEarlyTermination: IOptionalEarlyTermination;
}

export interface IEarlyTerminationProvisionBuilder extends IConcept {
   id: string;
}

export interface IPremiumExpression extends IConcept {
   premiumType: PremiumTypeEnum;
   pricePerOption: IMoney;
   percentageOfNotional: number;
}

export interface IPremiumExpressionBuilder extends IConcept {
   premiumType: PremiumTypeEnum;
   percentageOfNotional: number;
}

export interface IFxFeatureBuilder extends IConcept {
   referenceCurrency: string;
   referenceCurrencyScheme: string;
}

export interface IFxFeature extends IConcept {
   referenceCurrency: string;
   composite: IComposite;
   quanto: IQuanto;
   crossCurrency: IComposite;
   referenceCurrencyScheme: string;
}

export enum WeeklyRollConventionEnum {
   TBILL = 'TBILL',
   MON = 'MON',
   TUE = 'TUE',
   WED = 'WED',
   THU = 'THU',
   FRI = 'FRI',
   SAT = 'SAT',
   SUN = 'SUN',
}

export interface IRosetta extends IConcept {
}

export interface IIdentifiedAssetBuilder extends IConcept {
   id: string;
   instrumentIdentifierScheme: string;
   description: string;
   instrumentIdentifier: string[];
}

export interface IIdentifiedAsset extends IConcept {
   id: string;
   instrumentIdentifierScheme: string;
   description: string;
   instrumentIdentifier: string[];
}

export interface ICrossCurrencyMethodBuilder extends IConcept {
   cashSettlementCurrencyScheme: string;
   cashSettlementCurrency: string[];
   quotationRateType: QuotationRateTypeEnum;
}

export interface ICrossCurrencyMethod extends IConcept {
   cashSettlementCurrencyScheme: string;
   cashSettlementReferenceBanks: ICashSettlementReferenceBanks[];
   cashSettlementCurrency: string[];
   quotationRateType: QuotationRateTypeEnum;
}

export interface IContractReferenceBuilder extends IConcept {
   state: StateEnum;
   accountReference: string;
   partyReference: string;
   issuer: string;
   issuerScheme: string;
   version: number;
}

export interface IContractReference extends IConcept {
   state: StateEnum;
   rosettaKey: string;
   accountReference: string;
   partyReference: string;
   identifierValue: IIdentifierValue;
   issuer: string;
   issuerScheme: string;
   version: number;
}

export enum RestructuringEnum {
   MOD_MOD_R = 'MOD_MOD_R',
   MOD_R = 'MOD_R',
   R = 'R',
}

export interface IOptionFeatureBuilder extends IConcept {
}

export interface IOptionFeature extends IConcept {
   fxFeature: IFxFeature;
   strategyFeature: IStrategyFeature;
   asian: IAsian;
   barrier: IBarrier;
   knock: IKnock;
   passThrough: IPassThrough;
}

export interface ILegalEntityBuilder extends IConcept {
   name: string;
   id: string;
   entityId: string;
   entityIdScheme: string;
   nameScheme: string;
}

export interface ILegalEntity extends IConcept {
   name: string;
   id: string;
   entityId: string;
   entityIdScheme: string;
   nameScheme: string;
}

export enum StateEnum {
   ALLOCATED = 'ALLOCATED',
   EXERCISED = 'EXERCISED',
   NOVATED = 'NOVATED',
   TERMINATED = 'TERMINATED',
}

export interface IMasterConfirmation extends IConcept {
   masterConfirmationType: MasterConfirmationTypeEnum;
   masterConfirmationDate: Date;
   masterConfirmationAnnexDate: Date;
   masterConfirmationAnnexType: MasterConfirmationAnnexTypeEnum;
   masterConfirmationAnnexTypeScheme: string;
   masterConfirmationTypeScheme: string;
}

export interface IMasterConfirmationBuilder extends IConcept {
   masterConfirmationType: MasterConfirmationTypeEnum;
   masterConfirmationDate: Date;
   masterConfirmationAnnexDate: Date;
   masterConfirmationAnnexType: MasterConfirmationAnnexTypeEnum;
   masterConfirmationAnnexTypeScheme: string;
   masterConfirmationTypeScheme: string;
}

export interface ICommodity extends IConcept {
}

export interface ICommodityBuilder extends IConcept {
}

export interface IBusinessCenterTime extends IConcept {
   businessCenterScheme: string;
   businessCenter: BusinessCenterEnum;
   hourMinuteTime: Date;
}

export interface IBusinessCenterTimeBuilder extends IConcept {
   businessCenterScheme: string;
   businessCenter: BusinessCenterEnum;
   hourMinuteTime: Date;
}

export enum NegativeInterestRateTreatmentEnum {
   NEGATIVE_INTEREST_RATE_METHOD = 'NEGATIVE_INTEREST_RATE_METHOD',
   ZERO_INTEREST_RATE_METHOD = 'ZERO_INTEREST_RATE_METHOD',
}

export interface IGracePeriodExtensionBuilder extends IConcept {
   applicable: boolean;
}

export interface IGracePeriodExtension extends IConcept {
   applicable: boolean;
   gracePeriod: IOffset;
}

export interface IPrincipalExchangesBuilder extends IConcept {
   id: string;
   initialExchange: boolean;
   finalExchange: boolean;
   intermediateExchange: boolean;
}

export interface IPrincipalExchanges extends IConcept {
   id: string;
   initialExchange: boolean;
   finalExchange: boolean;
   intermediateExchange: boolean;
}

export enum RateTreatmentEnum {
   BOND_EQUIVALENT_YIELD = 'BOND_EQUIVALENT_YIELD',
   MONEY_MARKET_YIELD = 'MONEY_MARKET_YIELD',
}

export interface IBond extends IConcept {
   paymentFrequency: IPeriod;
   dayCountFractionScheme: string;
   parValue: number;
   issuanceFaceAmount: number;
   dayCountFraction: DayCountFractionEnum;
   couponTypeScheme: string;
   seniorityScheme: string;
   issuerName: string;
   issuerReference: string;
   seniority: CreditSeniorityEnum;
   couponType: CouponTypeEnum;
   couponRate: number;
   maturity: Date;
   issueDate: Date;
   id: string;
   currency: string;
   clearanceSystemScheme: string;
   productIdentifierScheme: string;
   productIdentifier: IProductIdentifier[];
   productTaxonomy: IProductTaxonomy[];
   description: string;
   clearanceSystem: string;
   currencyScheme: string;
}

export interface IBondBuilder extends IConcept {
   dayCountFractionScheme: string;
   parValue: number;
   issuanceFaceAmount: number;
   dayCountFraction: DayCountFractionEnum;
   couponTypeScheme: string;
   seniorityScheme: string;
   issuerName: string;
   issuerReference: string;
   seniority: CreditSeniorityEnum;
   couponType: CouponTypeEnum;
   couponRate: number;
   maturity: Date;
   issueDate: Date;
   id: string;
   currency: string;
   clearanceSystemScheme: string;
   productIdentifierScheme: string;
   description: string;
   clearanceSystem: string;
   currencyScheme: string;
}

export enum MatrixTermEnum {
   IVS_1_OPEN_MARKETS = 'IVS_1_OPEN_MARKETS',
}

export enum AveragingInOutEnum {
   IN = 'IN',
   OUT = 'OUT',
   BOTH = 'BOTH',
}

export interface IPrincipalExchange extends IConcept {
   id: string;
   discountFactor: number;
   unadjustedPrincipalExchangeDate: Date;
   adjustedPrincipalExchangeDate: Date;
   principalExchangeAmount: number;
   presentValuePrincipalExchangeAmount: IMoney;
}

export interface IPrincipalExchangeBuilder extends IConcept {
   id: string;
   discountFactor: number;
   unadjustedPrincipalExchangeDate: Date;
   adjustedPrincipalExchangeDate: Date;
   principalExchangeAmount: number;
}

export interface IReferencePair extends IConcept {
   referenceObligation: IReferenceObligation;
   referenceEntity: ILegalEntity;
   noReferenceObligation: boolean;
   entityType: EntityTypeEnum;
   entityTypeScheme: string;
}

export interface IReferencePairBuilder extends IConcept {
   noReferenceObligation: boolean;
   entityType: EntityTypeEnum;
   entityTypeScheme: string;
}

export enum SettlementRateOptionEnum {
   ARS_BNAR_ARS01 = 'ARS_BNAR_ARS01',
   ARS_EMTA_INDICATIVE_SURVEY_RATE_ARS04 = 'ARS_EMTA_INDICATIVE_SURVEY_RATE_ARS04',
   BRL_PTAX_BRL09 = 'BRL_PTAX_BRL09',
   CNY_SAEC_CNY01 = 'CNY_SAEC_CNY01',
   KRW_KFTC18_KRW02 = 'KRW_KFTC18_KRW02',
   INR_RBIB_INR01 = 'INR_RBIB_INR01',
}

export interface ITermsChangePrimitive extends IConcept {
   before: IContractOrContractReference;
   after: IContractOrContractReference;
}

export interface ITermsChangePrimitiveBuilder extends IConcept {
}

export interface IRounding extends IConcept {
   roundingDirection: RoundingDirectionEnum;
   precision: number;
}

export interface IRoundingBuilder extends IConcept {
   roundingDirection: RoundingDirectionEnum;
   precision: number;
}

export interface IProductIdentificationBuilder extends IConcept {
   productQualifier: string;
   primaryAssetClass: AssetClassEnum;
   secondaryAssetClass: AssetClassEnum[];
   productType: string[];
   productId: string[];
   productIdScheme: string;
   primaryAssetClassScheme: string;
   productTypeScheme: string;
   secondaryAssetClassScheme: string;
}

export interface IProductIdentification extends IConcept {
   productQualifier: string;
   primaryAssetClass: AssetClassEnum;
   secondaryAssetClass: AssetClassEnum[];
   productType: string[];
   productId: string[];
   productIdScheme: string;
   primaryAssetClassScheme: string;
   productTypeScheme: string;
   secondaryAssetClassScheme: string;
}

export interface IAveragingSchedule extends IConcept {
   endDate: Date;
   startDate: Date;
   averagingPeriodFrequency: ICalculationPeriodFrequency;
}

export interface IAveragingScheduleBuilder extends IConcept {
   endDate: Date;
   startDate: Date;
}

export interface IDateTimeListBuilder extends IConcept {
   dateTime: Date[];
}

export interface IDateTimeList extends IConcept {
   dateTime: Date[];
}

export interface IMakeWholeAmountBuilder extends IConcept {
   interpolationMethod: InterpolationMethodEnum;
   earlyCallDate: Date;
   floatingRateIndex: FloatingRateIndexEnum;
   spread: number;
   side: QuotationSideEnum;
}

export interface IMakeWholeAmount extends IConcept {
   interpolationMethod: InterpolationMethodEnum;
   earlyCallDate: Date;
   floatingRateIndex: FloatingRateIndexEnum;
   indexTenor: IPeriod;
   spread: number;
   side: QuotationSideEnum;
}

export interface IBondReferenceBuilder extends IConcept {
   conditionPrecedentBond: boolean;
   discrepancyClause: boolean;
}

export interface IBondReference extends IConcept {
   bond: IBond;
   conditionPrecedentBond: boolean;
   discrepancyClause: boolean;
}

export interface IValuationPostponement extends IConcept {
   maximumDaysOfPostponement: number;
}

export interface IValuationPostponementBuilder extends IConcept {
   maximumDaysOfPostponement: number;
}

export interface ISettlementProvision extends IConcept {
   settlementCurrency: string;
   nonDeliverableSettlement: INonDeliverableSettlement;
   settlementCurrencyScheme: string;
}

export interface ISettlementProvisionBuilder extends IConcept {
   settlementCurrency: string;
   settlementCurrencyScheme: string;
}

export interface ICashflowBaseBuilder extends IConcept {
   id: string;
   discountFactor: number;
}

export interface ICashflowBase extends IConcept {
   id: string;
   discountFactor: number;
   presentValueAmount: IMoney;
   premiumExpression: IPremiumExpression;
   paymentDiscounting: IPaymentDiscounting;
   payerReceiver: IPayerReceiver;
}

export interface IResource extends IConcept {
   length: IResourceLength;
   name: string;
   language: string;
   resourceId: string;
   resourceType: ResourceTypeEnum;
   sizeInBytes: number;
   mimeType: string;
   comments: string;
   url: string;
   string: string;
   languageScheme: string;
   mimeTypeScheme: string;
   resourceIdScheme: string;
   resourceTypeScheme: string;
}

export interface IResourceBuilder extends IConcept {
   name: string;
   language: string;
   resourceId: string;
   resourceType: ResourceTypeEnum;
   sizeInBytes: number;
   mimeType: string;
   comments: string;
   url: string;
   string: string;
   languageScheme: string;
   mimeTypeScheme: string;
   resourceIdScheme: string;
   resourceTypeScheme: string;
}

export interface IReferenceObligationBuilder extends IConcept {
   primaryObligorReference: string;
   guarantorReference: string;
   standardReferenceObligation: boolean;
}

export interface IReferenceObligation extends IConcept {
   mortgage: IMortgage;
   bond: IBond;
   convertibleBond: IConvertibleBond;
   loan: ILoan;
   primaryObligor: ILegalEntity;
   primaryObligorReference: string;
   guarantor: ILegalEntity;
   guarantorReference: string;
   standardReferenceObligation: boolean;
}

export enum ValuationMethodEnum {
   MARKET = 'MARKET',
   HIGHEST = 'HIGHEST',
   AVERAGE_MARKET = 'AVERAGE_MARKET',
   AVERAGE_HIGHEST = 'AVERAGE_HIGHEST',
   BLENDED_MARKET = 'BLENDED_MARKET',
   BLENDED_HIGHEST = 'BLENDED_HIGHEST',
   AVERAGE_BLENDED_MARKET = 'AVERAGE_BLENDED_MARKET',
   AVERAGE_BLENDED_HIGHEST = 'AVERAGE_BLENDED_HIGHEST',
}

export interface IExecutionBuilder extends IConcept {
}

export interface IExecution extends IConcept {
   tradeHeader: ITradeHeader;
   contractualProduct: IContractualProduct;
   party: IParty[];
}

export interface IInformationSource extends IConcept {
   sourceProvider: InformationProviderEnum;
   sourcePage: string;
   sourcePageHeading: string;
   sourcePageScheme: string;
   sourceProviderScheme: string;
}

export interface IInformationSourceBuilder extends IConcept {
   sourceProvider: InformationProviderEnum;
   sourcePage: string;
   sourcePageHeading: string;
   sourcePageScheme: string;
   sourceProviderScheme: string;
}

export interface IMandatoryEarlyTerminationAdjustedDates extends IConcept {
   adjustedEarlyTerminationDate: Date;
   adjustedCashSettlementValuationDate: Date;
   adjustedCashSettlementPaymentDate: Date;
}

export interface IMandatoryEarlyTerminationAdjustedDatesBuilder extends IConcept {
   adjustedEarlyTerminationDate: Date;
   adjustedCashSettlementValuationDate: Date;
   adjustedCashSettlementPaymentDate: Date;
}

export interface IInitialFixingDateBuilder extends IConcept {
   initialFixingDate: Date;
}

export interface IPeriod extends IConcept {
   id: string;
   period: PeriodEnum;
   periodMultiplier: number;
}

export interface IInitialFixingDate extends IConcept {
   initialFixingDate: Date;
   relativeDateOffset: IRelativeDateOffset;
}

export interface IOptionCashSettlement extends IConcept {
   id: string;
   cashSettlementPaymentDate: ICashSettlementPaymentDate;
   cashSettlementValuationTime: IBusinessCenterTime;
   cashSettlementValuationDate: IRelativeDateOffset;
   cashPriceMethod: ICashPriceMethod;
   cashPriceAlternateMethod: ICashPriceMethod;
   parYieldCurveAdjustedMethod: IYieldCurveMethod;
   zeroCouponYieldAdjustedMethod: IYieldCurveMethod;
   parYieldCurveUnadjustedMethod: IYieldCurveMethod;
   crossCurrencyMethod: ICrossCurrencyMethod;
   collateralizedCashPriceMethod: IYieldCurveMethod;
}

export interface IOptionCashSettlementBuilder extends IConcept {
   id: string;
}

export interface INotionalStepRuleBuilder extends IConcept {
   notionalStepAmount: number;
   notionalStepRate: number;
   stepRelativeTo: StepRelativeToEnum;
   firstNotionalStepDate: Date;
   lastNotionalStepDate: Date;
   calculationPeriodDatesReference: string;
}

export interface INotionalStepRule extends IConcept {
   notionalStepAmount: number;
   notionalStepRate: number;
   stepRelativeTo: StepRelativeToEnum;
   stepFrequency: IFrequency;
   firstNotionalStepDate: Date;
   lastNotionalStepDate: Date;
   calculationPeriodDatesReference: string;
}

export interface IInflationRateCalculation extends IConcept {
   inflationLag: IOffset;
   indexSource: string;
   mainPublication: string;
   interpolationMethod: InterpolationMethodEnum;
   initialIndexLevel: number;
   fallbackBondApplicable: boolean;
   indexSourceScheme: string;
   interpolationMethodScheme: string;
   mainPublicationScheme: string;
   initialRate: number;
   finalRateRounding: IRounding;
   averagingMethod: AveragingMethodEnum;
   negativeInterestRateTreatment: NegativeInterestRateTreatmentEnum;
   id: string;
   spreadSchedule: ISpreadSchedule[];
   floatingRateIndexScheme: string;
   floatingRateMultiplierSchedule: ISchedule;
   floatingRateIndex: FloatingRateIndexEnum;
   indexTenor: IPeriod;
   rateTreatment: RateTreatmentEnum;
   capRateSchedule: IStrikeSchedule[];
   floorRateSchedule: IStrikeSchedule[];
}

export interface IInflationRateCalculationBuilder extends IConcept {
   indexSource: string;
   mainPublication: string;
   interpolationMethod: InterpolationMethodEnum;
   initialIndexLevel: number;
   fallbackBondApplicable: boolean;
   indexSourceScheme: string;
   interpolationMethodScheme: string;
   mainPublicationScheme: string;
   initialRate: number;
   averagingMethod: AveragingMethodEnum;
   negativeInterestRateTreatment: NegativeInterestRateTreatmentEnum;
   id: string;
   floatingRateIndexScheme: string;
   floatingRateIndex: FloatingRateIndexEnum;
   rateTreatment: RateTreatmentEnum;
}

export interface IQuantityChangePrimitiveBuilder extends IConcept {
}

export interface IQuantityChangePrimitive extends IConcept {
   before: IContractOrContractReference;
   change: IContractualQuantity[];
   after: IContractOrContractReference;
}

export interface IDocumentation extends IConcept {
   contractualDefinitions: ContractualDefinitionsEnum[];
   contractualTermsSupplement: IContractualTermsSupplement[];
   masterAgreement: IMasterAgreement;
   brokerConfirmation: IBrokerConfirmation;
   creditSupportAgreement: ICreditSupportAgreement;
   otherAgreement: IOtherAgreement[];
   attachment: IResource[];
   masterConfirmation: IMasterConfirmation;
   contractualMatrix: IContractualMatrix[];
   contractualDefinitionsScheme: string;
}

export interface IDocumentationBuilder extends IConcept {
   contractualDefinitions: ContractualDefinitionsEnum[];
   contractualDefinitionsScheme: string;
}

export enum CompoundingMethodEnum {
   FLAT = 'FLAT',
   NONE = 'NONE',
   STRAIGHT = 'STRAIGHT',
   SPREAD_EXCLUSIVE = 'SPREAD_EXCLUSIVE',
}

export interface IExercisePeriod extends IConcept {
   id: string;
   earliestExerciseDateTenor: IPeriod;
   exerciseFrequency: IPeriod;
}

export interface IExercisePeriodBuilder extends IConcept {
   id: string;
}

export interface IAdjustableDate extends IConcept {
   id: string;
   unadjustedDate: Date;
   dateAdjustmentsReference: string;
   adjustedDate: Date;
   dateAdjustments: IBusinessDayAdjustments;
}

export interface IAdjustableDateBuilder extends IConcept {
   id: string;
   unadjustedDate: Date;
   dateAdjustmentsReference: string;
   adjustedDate: Date;
}

export interface IStubFloatingRate extends IConcept {
   id: string;
   spreadSchedule: ISpreadSchedule[];
   floatingRateMultiplierSchedule: ISchedule;
   floatingRateIndex: FloatingRateIndexEnum;
   indexTenor: IPeriod;
   rateTreatment: RateTreatmentEnum;
   capRateSchedule: IStrikeSchedule[];
   floorRateSchedule: IStrikeSchedule[];
}

export interface IStubFloatingRateBuilder extends IConcept {
   id: string;
   floatingRateIndex: FloatingRateIndexEnum;
   rateTreatment: RateTreatmentEnum;
}

export enum DayCountFractionEnum {
   _1_1 = '_1_1',
   _30_360 = '_30_360',
   _30E_360 = '_30E_360',
   _30E_360_ISDA = '_30E_360_ISDA',
   ACT_360 = 'ACT_360',
   ACT_365_FIXED = 'ACT_365_FIXED',
   ACT_365L = 'ACT_365L',
   ACT_ACT_AFB = 'ACT_ACT_AFB',
   ACT_ACT_ICMA = 'ACT_ACT_ICMA',
   ACT_ACT_ISDA = 'ACT_ACT_ISDA',
   ACT_ACT_ISMA = 'ACT_ACT_ISMA',
   BUS_252 = 'BUS_252',
}

export interface IPriorDateInstanceBuilder extends IConcept {
   date: Date;
}

export interface IPriorDateInstance extends IConcept {
   contractReference: IIdentifier;
   date: Date;
}

export interface IDateRelativeToCalculationPeriodDates extends IConcept {
   calculationPeriodDatesReference: string[];
}

export interface IDateRelativeToCalculationPeriodDatesBuilder extends IConcept {
   calculationPeriodDatesReference: string[];
}

export enum NaturalPersonRoleEnum {
   TRADER = 'TRADER',
}

export interface ICompositeBuilder extends IConcept {
   determinationMethod: DeterminationMethodEnum;
}

export interface IComposite extends IConcept {
   fxSpotRateSource: IFxSpotRateSource;
   determinationMethod: DeterminationMethodEnum;
   relativeDate: IRelativeDateOffset;
}

export interface IAveragingObservationListBuilder extends IConcept {
}

export interface IAveragingObservationList extends IConcept {
   averagingObservation: IWeightedAveragingObservation[];
}

export enum TransferStatusEnum {
   DISPUTED = 'DISPUTED',
   INSTRUCTED = 'INSTRUCTED',
   PENDING = 'PENDING',
   SETTLED = 'SETTLED',
}

export interface IListedHeader extends IConcept {
   id: string;
   currency: string;
   clearanceSystemScheme: string;
   productIdentifierScheme: string;
   productIdentifier: IProductIdentifier[];
   productTaxonomy: IProductTaxonomy[];
   description: string;
   clearanceSystem: string;
   currencyScheme: string;
}

export interface IListedHeaderBuilder extends IConcept {
   id: string;
   currency: string;
   clearanceSystemScheme: string;
   productIdentifierScheme: string;
   description: string;
   clearanceSystem: string;
   currencyScheme: string;
}

export interface IOptionPhysicalSettlementBuilder extends IConcept {
   clearedPhysicalSettlement: boolean;
   predeterminedClearingOrganizationPartyReference: string;
}

export interface IOptionPhysicalSettlement extends IConcept {
   clearedPhysicalSettlement: boolean;
   predeterminedClearingOrganizationPartyReference: string;
}

export interface IPackageInformation extends IConcept {
   category: CategoryEnum[];
   relatedParty: IRelatedParty[];
   intentToAllocate: boolean;
}

export interface IPackageInformationBuilder extends IConcept {
   category: CategoryEnum[];
   intentToAllocate: boolean;
}

export interface ICashflow extends IConcept {
   cashflowDate: IAdjustableOrAdjustedOrRelativeDate;
   rosettaKeyValue: string;
   cashflowCalculation: string;
   cashflowType: CashflowTypeEnum;
   cashflowAmount: IMoney;
   id: string;
   discountFactor: number;
   presentValueAmount: IMoney;
   premiumExpression: IPremiumExpression;
   paymentDiscounting: IPaymentDiscounting;
   payerReceiver: IPayerReceiver;
}

export interface ICashflowBuilder extends IConcept {
   cashflowCalculation: string;
   cashflowType: CashflowTypeEnum;
   id: string;
   discountFactor: number;
}

export enum CommodityReferencePriceEnum {
   ALUMINIUM_ALLOY_LME_15_MONTH = 'ALUMINIUM_ALLOY_LME_15_MONTH',
}

export interface IPeriodBuilder extends IConcept {
   id: string;
   period: PeriodEnum;
   periodMultiplier: number;
}

export interface ICashSettlementTerms extends IConcept {
   id: string;
   quotationAmount: IMoney;
   minimumQuotationAmout: IMoney;
   accruedInterest: boolean;
   settlementCurrency: string;
   cashSettlementBusinessDays: number;
   valuationDate: IValuationDate;
   valuationTime: IBusinessCenterTime;
   quotationMethod: QuotationRateTypeEnum;
   dealer: string;
   cashSettlementAmount: IMoney;
   fixedSettlement: boolean;
   valuationMethod: ValuationMethodEnum;
   recoveryFactor: number;
   settlementCurrencyScheme: string;
}

export interface ICashSettlementTermsBuilder extends IConcept {
   id: string;
   accruedInterest: boolean;
   settlementCurrency: string;
   cashSettlementBusinessDays: number;
   quotationMethod: QuotationRateTypeEnum;
   dealer: string;
   fixedSettlement: boolean;
   valuationMethod: ValuationMethodEnum;
   recoveryFactor: number;
   settlementCurrencyScheme: string;
}

export interface IRateObservationBuilder extends IConcept {
   id: string;
   observationWeight: number;
   resetDate: Date;
   adjustedFixingDate: Date;
   observedRate: number;
   treatedRate: number;
   rateReference: string;
   forecastRate: number;
   treatedForecastRate: number;
}

export interface IRateObservation extends IConcept {
   id: string;
   observationWeight: number;
   resetDate: Date;
   adjustedFixingDate: Date;
   observedRate: number;
   treatedRate: number;
   rateReference: string;
   forecastRate: number;
   treatedForecastRate: number;
}

export interface IMasterAgreement extends IConcept {
   masterAgreementId: string;
   masterAgreementType: MasterAgreementTypeEnum;
   masterAgreementVersion: string;
   masterAgreementDate: Date;
   masterAgreementIdScheme: string;
   masterAgreementTypeScheme: string;
   masterAgreementVersionScheme: string;
}

export interface IMasterAgreementBuilder extends IConcept {
   masterAgreementId: string;
   masterAgreementType: MasterAgreementTypeEnum;
   masterAgreementVersion: string;
   masterAgreementDate: Date;
   masterAgreementIdScheme: string;
   masterAgreementTypeScheme: string;
   masterAgreementVersionScheme: string;
}

export interface IScheduleBuilder extends IConcept {
   id: string;
   initialValue: number;
}

export interface ISchedule extends IConcept {
   id: string;
   initialValue: number;
   step: IStep[];
}

export interface IOptionDenomination extends IConcept {
   optionEntitlement: number;
   numberOfOptions: number;
   entitlementCurrency: string;
   entitlementCurrencyScheme: string;
}

export interface IOptionDenominationBuilder extends IConcept {
   optionEntitlement: number;
   numberOfOptions: number;
   entitlementCurrency: string;
   entitlementCurrencyScheme: string;
}

